﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Globalization;
//using SBSDK_API;

namespace SBARCO_SDK
{
    public partial class Form1 : Form
    {
        //Port Function
        [DllImport("SBSDK_API.dll")]
        static unsafe extern bool PortOpen(StringBuilder pPortName);

        [DllImport("SBSDK_API.dll")]
        static extern void PortClose();

        [DllImport("SBSDK_API.dll")]
        static extern int PortEnumCount(int nPortType);

        [DllImport("SBSDK_API.dll")]
        static unsafe extern bool PortEnumGet(int nPortType, int nItem, StringBuilder pBuffer);

        [DllImport("SBSDK_API.dll")]
        static extern bool PortSetupSerial(int nBaudRate, int nDataBits, int nParity, int nStopBits, int nFlowControl);

        //Setting Function
        [DllImport("SBSDK_API.dll")]
        static extern bool SetAfterPrint(int nType, int nCutPiece);

        [DllImport("SBSDK_API.dll")]
        static extern bool SetFontCharacterSet(int nMeasurement, int nResolution);

        [DllImport("SBSDK_API.dll")]
        static extern bool SetMeasurement(int nMeasurement, int nResolution);

        [DllImport("SBSDK_API.dll")]
        static extern bool SetMedia_Continuous(float fLabelWidth, float fLabelLen, float fStopOffset);

        [DllImport("SBSDK_API.dll")]
        static extern bool SetMedia_LabelWithGaps(float nLabelWidth, float nLabelLen, float nGapLen, float nGapOffset);

        [DllImport("SBSDK_API.dll")]
        static extern bool SetMedia_LabelWithMarks(float fLabelWidth, float fLabelLen, float fBlackLineLen, float fThicknessOffset);

        [DllImport("SBSDK_API.dll")]
        static extern bool SetPrinter(int nSpeed, int nDarkness, int bDirectThermal);

        [DllImport("SBSDK_API.dll")]
        static extern bool SetReferencePoint(int nHoriDot, int nVertDot);

        [DllImport("SBSDK_API.dll")]
        static extern bool SetTPH_YOffset(int nOffsetDot);

        //Print Function
        [DllImport("SBSDK_API.dll")]
        static extern bool PrintText(float fX, float fY, int nRotation, int nFontID, int nFontHor, int nFontVer, int bReverse, int nDataLen, string pData);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintBarcode(float fX, float fY, float fBarHeight, int nRotation, int nBarType, int nNarrowBar, int nWideBar, int bHuman, int nDataLen, string pData);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintPDF417(float fX, float fY, int nRotation, int nCorrectionLevel, int bCompression, int nModuleWidth,
                                int nBarHeight, int nMaxColumns, int nMaxRows, int nTruncated, int nDataLen, string pData);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintDataMatrix(float fX, float fY, int nRotation, int nColumns, int nRows, int nSquare, int bInverseImage, int nDataLen, string pData);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintMaxiCode(float fX, float fY, int nRotation, int nMode, int nDataLen, string pData);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintQRcode(float fX, float fY, int nRotation, int nErrorCorrection, int nModel, int nMaskNumber, int nPixel, int nDataLen, string pData);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintImage(float fX, float fY, float fWidth, float fHeight, int nRotation, int bErrorDiffusion, string pFileName);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintTrueTypeFontA(float fX, float fY, int nFontH, int nFontW, int nRotation, int nStyle, int bUnderline, int bWhitOnBlack, string pFaceName, string pText);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintTrueTypeFontW(float fX, float fY, int nFontH, int nFontW, int nRotation, int nStyle, int bUnderline, int bWhitOnBlack, string ptcFaceName, string ptcText);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintTTF_AlignmentA(float fX, float fY, float fRangeWidth, int nAlignment, int nFontH, int nFontW, int nRotation, int nStyle, int bUnderline, int bWhitOnBlack, string pFaceName, string pText);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintTTF_AlignmentW(float fX, float fY, float fRangeWidth, int nAlignment, int nFontH, int nFontW, int nRotation, int nStyle, int bUnderline, int bWhitOnBlack, string ptcFaceName, string ptcText);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintParagraphA(float fX, float fY, float fRangeWidth, int nAlignment, int nFontH, int nFontW, int nRotation, int nStyle, int bUnderline, int bWhitOnBlack, string pFaceName, string pText);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintBox(float fX1, float fY1, int nThickness, float fX2, float fY2);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintLine(float fX, float fY, float fHoriLength, float fVertLength, int nDrawMethod);

        [DllImport("SBSDK_API.dll")]
        static extern bool PrintLabel(int nSet, int nCopy, int bReverse);

        [DllImport("SBSDK_API.dll")]
        static extern bool Image_Save(float fWidth, float fHeight, int nRotation, int bErrorDiffusion, string pFileName, string pIDString);
        
        [DllImport("SBSDK_API.dll")]
        static extern bool Image_Print(float fX, float fY, string pIDString);

        [DllImport("SBSDK_API.dll")]
        static extern bool Image_Delete(string pIDString);

        // Form Function
        [DllImport("SBSDK_API.dll")]
        static extern int FormSaveByFileA(string pFileName);

        [DllImport("SBSDK_API.dll")]
        static extern int FormSaveByFileW(string ptcFileName);

        [DllImport("SBSDK_API.dll")]
        static extern bool FormCheck(string pFormName);

        [DllImport("SBSDK_API.dll")]
        static extern bool FormExecute(string pFormName);

        [DllImport("SBSDK_API.dll")]
        static extern bool FormParameterData(string pData);

        [DllImport("SBSDK_API.dll")]
        static extern bool FormPrint(int nSet, int nCopy);

        // Demand Functions
        [DllImport("SBSDK_API.dll")]
        static extern bool DemandCalibrationTest();
        
        [DllImport("SBSDK_API.dll")]
        static extern bool DemandFactoryDefaults();
        
        [DllImport("SBSDK_API.dll")]
        static extern bool DemandResetPrinter();
        
        [DllImport("SBSDK_API.dll")]
        static extern bool DemandLabelFeed();
        
        [DllImport("SBSDK_API.dll")]
        static extern bool DemandPrintConfiguration();
        
        // Getting Functions
        [DllImport("SBSDK_API.dll")]
        static extern int GetEmulationType();
        
        [DllImport("SBSDK_API.dll")]
        static extern int GetFirmwareVersion(StringBuilder pBuffer);
        
        [DllImport("SBSDK_API.dll")]
        static extern int GetPrintDistance(int nMeasurement);
        
        [DllImport("SBSDK_API.dll")]
        static extern int GetPrinterStatus();
        
        [DllImport("SBSDK_API.dll")]
        static extern int GetResolution();
        
        [DllImport("SBSDK_API.dll")]
        static extern int GetSerialNumber(StringBuilder pBuffer);

        [DllImport("SBSDK_API.dll")]
        static extern int GetReferencePoint(int nAxisType);

        [DllImport("SBSDK_API.dll")]
        static extern int GetTPH_YOffset();


        // Other Functions
        [DllImport("SBSDK_API.dll")]
        static extern double DllAbout(int bDisplay);
        
        [DllImport("SBSDK_API.dll")]
        static extern int SendCmd(int nDataLen, StringBuilder lpData);
        
        [DllImport("SBSDK_API.dll")]
        static extern int SendFileA(string pFileName);
        
        [DllImport("SBSDK_API.dll")]
        static extern int SendFileW(string ptcFileName);

        // BarDrawer Functions
        [DllImport("SBSDK_API.dll")]
        static extern bool BarDrawer_DatabaseSet(int nType, int nSaveInfos, string pstrFilePath, string pstrUserName, string pstrPassword, string pstrTable);
        
        [DllImport("SBSDK_API.dll")]
        static extern bool BarDrawer_Launch(string pFileName);
        
        [DllImport("SBSDK_API.dll")]
        static extern bool BarDrawer_LaunchNew(string pFileName);

        [DllImport("SBSDK_API.dll")]
        static extern void CmdParserA(string ptcString);

        [DllImport("SBSDK_API.dll")]
        static extern void CmdParserW(string ptcString);
        

        public Form1()
        {
            InitializeComponent();
        }


        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void But_Text_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        
            if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }
	        
            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4, 3, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            PrintText(2.0f, 1.5f, 0, 2, 1, 1, 0, 8, "AaBbCcDd"); // X=2.0, Y=1.5 (inches), No rotation, Font2, Hor Expand=1, Ver Expand=1, normal image
            PrintText(2.0f, 1.5f, 90, 2, 1, 1, 0, 8, "AaBbCcDd"); // X=2.0, Y=1.5 (inches), 90 rotation, Font2, Hor Expand=1, Ver Expand=1, normal image
            PrintText(2.0f, 1.5f, 180, 2, 1, 1, 0, 8, "AaBbCcDd"); // X=2.0, Y=1.5 (inches), 180 rotation, Font2, Hor Expand=1, Ver Expand=1, normal image
            PrintText(2.0f, 1.5f, 270, 2, 1, 1, 0, 8, "AaBbCcDd"); // X=2.0, Y=1.5 (inches), 270 rotation, Font2, Hor Expand=1, Ver Expand=1, normal image

            PrintLabel(1, 1, 0);//nSet, nCopy, bReverse
            PortClose();
        }

        private unsafe void But_EnumerateUSBPort_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(0); // Get USB count
            StringBuilder acPortBuffer = new StringBuilder("");

            if (nPortCount > 0)
            {
                PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
                PortOpen(acPortBuffer);
                SetMeasurement(1, 0); // inchs
                PrintText(0.2f, 0.2f, 0, 2, 1, 1, 0, 15, "Print from TEST");
                PrintLabel(1, 1, 0);
                PortClose();
            }


        }

        private void But_Ethernet_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(3); // Get Ethernet IP Address count
            StringBuilder acPortBuffer = new StringBuilder("");

	        if(nPortCount > 0)
	        {
		        PortEnumGet(3, 0, acPortBuffer); // Get IP Address of number 0 of Ethernet
		        PortOpen(acPortBuffer);
		        //PortOpen("192.168.11.2");
		        SetMeasurement(1, 0); // inchs
		        PrintText(1.1f, 0.2f, 0, 1, 1, 1, 0, 16, "Print from Ethernet");
		        PrintLabel(1, 1, 0);
		        PortClose();
	        }
        }

        private void But_Lptport_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(2); // Get LPT count
            StringBuilder acPortBuffer = new StringBuilder("");

	        if(nPortCount > 0)
	        {
		        PortEnumGet(2, 0, acPortBuffer); // Get name of number 0 of LPT port
		        PortOpen(acPortBuffer);
		        SetMeasurement(1, 0); // inchs
		        PrintText(1.1f, 0.2f, 0, 1, 1, 1, 0, 16, "Print from LPT");
		        PrintLabel(1, 1, 0);
		        PortClose();
	        }
        }

        private void But_EnumerateRS232Port_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(1); // Get RS232 count
            StringBuilder acPortBuffer = new StringBuilder("");

	        if(nPortCount > 0)
	        {
		        PortEnumGet(1, 0, acPortBuffer); // Get name of number 1 of RS232 port
		        PortSetupSerial(115200, 8, 0, 1, 1); // 115200 bps, 8 data-bits, no parity, 1 stop bit, hardware flowing control.
		        PortOpen(acPortBuffer);		
		        SetMeasurement(1, 0); // inchs
		        PrintText(1.1f, 0.2f, 0, 1, 1, 1, 0, 16, "Print from RS232");
		        PrintLabel(1, 1, 0);
		        PortClose();
	        }
        }

        private void But_SetRS232Port_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("COM1");
            
            PortSetupSerial(115200, 8, 0, 1, 1); // 115200 bps, 8 data-bits, no parity, 1 stop bit, hardware flowing control.
            PortOpen(acPortBuffer);
            SetMeasurement(1, 0); // inchs
            PrintText(1.1f, 0.2f, 0, 1, 1, 1, 0, 17, "Print from RS232");
            PrintLabel(1, 1, 0);
            PortClose();
        }

        private void But_TrueTypeFont_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(0); // Get USB count
            StringBuilder acPortBuffer = new StringBuilder("");
            PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
            if (!PortOpen(acPortBuffer))
            {
                MessageBox.Show("Can't open port!");
                return;
            }

            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4, 3, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 0); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            string TStr = "AaBbCcDd";

            PrintTrueTypeFontA(2.0f, 1.5f, 12, -1, 0, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintTrueTypeFontA(2.0f, 1.5f, 12, -1, 1, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=1, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintTrueTypeFontA(2.0f, 1.5f, 12, -1, 2, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=2, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintTrueTypeFontA(2.0f, 1.5f, 12, -1, 3, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=3, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintBox(1.2f, 0.7f, 2, 2.8f, 2.35f);
            
            PrintLabel(1, 1, 0);//nSet, nCopy, bReverse
            PortClose();
        }

        private void But_TtfAlign_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(0); // Get USB count
            StringBuilder acPortBuffer = new StringBuilder("");
            PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
            if (!PortOpen(acPortBuffer))
            {
                MessageBox.Show("Can't open port!");
                return;
            }

            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4, 3, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 0); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            string TStr = "AaBbCcDd";

            PrintTTF_AlignmentA(2.0f, 1.5f, 1.5f, 2, 12, -1, 0, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintTTF_AlignmentA(2.0f, 1.5f, 1.5f, 2, 12, -1, 1, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=1, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintTTF_AlignmentA(2.0f, 1.5f, 1.5f, 2, 12, -1, 2, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=2, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintTTF_AlignmentA(2.0f, 1.5f, 1.5f, 2, 12, -1, 3, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=3, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintBox(0.5f, 0.0f, 2, 3.5f, 3.0f);
            PrintBox(1.3f, 0.8f, 2, 2.7f, 2.2f);

            PrintLabel(1, 1, 0);//nSet, nCopy, bReverse
            PortClose();
        }

        private void But_Paragraph_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(0); // Get USB count
            StringBuilder acPortBuffer = new StringBuilder("");
            PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
            if (!PortOpen(acPortBuffer))
            {
                MessageBox.Show("Can't open port!");
                return;
            }

            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4, 3, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 0); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            string TStr = "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz";

            PrintParagraphA(2.0f, 1.5f, 1.5f, 2, 12, -1, 0, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintParagraphA(2.0f, 1.5f, 1.5f, 2, 12, -1, 1, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=1, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintParagraphA(2.0f, 1.5f, 1.5f, 2, 12, -1, 2, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=2, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintParagraphA(2.0f, 1.5f, 1.5f, 2, 12, -1, 3, 3, 0, 0, "Times New Roman", TStr); // nFontH=12, nFontW=-1, nRotation=3, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
            PrintBox(0.55f, 0.0f, 2, 3.5f, 3.0f);

            PrintLabel(1, 1, 0);//nSet, nCopy, bReverse
            PortClose();
        }

        private void But_Barcode_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(0); // Get USB count
            StringBuilder acPortBuffer = new StringBuilder("");
            PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
            if (!PortOpen(acPortBuffer))
            {
                MessageBox.Show("Can't open port!");
                return;
            }

            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4, 3, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 0); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            string TStr = "12345";

            PrintBarcode(2.0f, 1.5f, 0.3f, 0, 1, 2, 4, 1, 5, TStr); //fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl
            PrintBarcode(2.0f, 1.5f, 0.3f, 1, 1, 2, 4, 1, 5, TStr); //fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl
            PrintBarcode(2.0f, 1.5f, 0.3f, 2, 1, 2, 4, 1, 5, TStr); //fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl
            PrintBarcode(2.0f, 1.5f, 0.3f, 3, 1, 2, 4, 1, 5, TStr); //fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl
	

            PrintLabel(1, 1, 0);//nSet, nCopy, bReverse
            PortClose();
        }

        private void But_PDF417_Click(object sender, EventArgs e)
        {
            int nCorrectionLevel = 1;
	        int bCompression = 0;
	        int nModuleWidth = 2;
	        int nBarHeight = 4;
	        int nMaxColumns = 1;
	        int nMaxRows = 10;
	        int nTruncated = 0;
	        int nDataLen = 5;
	        string pData = "12345";
        	
	        StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4, 3, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 0); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            PrintPDF417(2.0f, 1.5f, 0, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData);
            PrintPDF417(2.0f, 1.5f, 1, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData);
            PrintPDF417(2.0f, 1.5f, 2, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData);
            PrintPDF417(2.0f, 1.5f, 3, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData);
            PrintBox(1.15f, 0.65f, 2, 2.9f, 2.4f);

            PrintLabel(1, 1, 0);//nSet, nCopy, bReverse
	        PortClose();
        }

        private void But_DataMatrix_Click(object sender, EventArgs e)
        {
	        int nRotation = 0;
	        int nColumns = 10;
	        int nRows = 10;
	        int nSquare = 4;
	        int bInverseImage = 0;
	        int nDataLen = 5;
	        string pData = "12345";

	        StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        SetMeasurement(1, 0); // inchs
        	
	        PrintDataMatrix(0.8f, 0.8f, nRotation, nColumns, nRows, nSquare, bInverseImage, nDataLen, pData);

	        PrintLabel(1, 1, 0);
	        PortClose();
        }

        private void But_MaxiCode_Click(object sender, EventArgs e)
        {
            int nRotation = 0;
	        int nMode = 0;
	        int nDataLen;
	        string pData = "300,840,93065,1692,This is MaxiCode,but not MaxiCode formatted data";

	        StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        SetMeasurement(1, 0); // inchs

            nDataLen = pData.Length;
	        PrintMaxiCode(0.8f, 0.8f, nRotation, nMode, nDataLen, pData);

	        PrintLabel(1, 1, 0);
	        PortClose();
        }

        private void But_Qrcode_Click(object sender, EventArgs e)
        {
            int nErrorCorrection = 0;
            int nModel = 2;
            int nMaskNumber = 0;
            int nPixel = 4;
            int nDataLen = 5;
            string pData = "12345";

            StringBuilder acPortBuffer = new StringBuilder("");
            int nPortCount = PortEnumCount(0); // Get USB count
            PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
            if (!PortOpen(acPortBuffer))
            {
                MessageBox.Show("Can't open port!");
                return;
            }

            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4, 3, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 0); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            PrintQRcode(2.0f, 1.5f, 0, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData);
            PrintQRcode(2.0f, 1.5f, 1, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData);
            PrintQRcode(2.0f, 1.5f, 2, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData);
            PrintQRcode(2.0f, 1.5f, 3, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData);
            PrintBox(1.49f, 0.99f, 2, 2.51f, 2.01f); // (0.5, 0.5) to (1, 1) inch with 12 dots thickness

            PrintLabel(1, 1, 0);//nSet, nCopy, bReverse
            PortClose();
        }

        private void But_Image_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4.0f, 3.0f, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 0); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            PrintImage(2.0f, 1.5f, 1.0f, 1.5f, 0, 1, "TestImage.jpg"); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
            PrintImage(2.0f, 1.5f, 1.0f, 1.5f, 1, 1, "TestImage.jpg"); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
            PrintImage(2.0f, 1.5f, 1.0f, 1.5f, 2, 1, "TestImage.jpg"); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
            PrintImage(2.0f, 1.5f, 1.0f, 1.5f, 3, 1, "TestImage.jpg"); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
            PrintBox(0.55f, 0.05f, 2, 3.45f, 2.95f);

            PrintLabel(1, 1, 0);//nSet, nCopy, bReverse
	        PortClose();
        }

        private void But_SaveImage_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

            SetMeasurement(1, 0); // inchs
            SetMedia_LabelWithGaps(4.0f, 3.0f, 0.16f, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
            SetPrinter(3, 8, 0); // nSpeed=3, nDarkness=8, bDirectThermal=1;

            // save image with the ID specified
            Image_Save(1.0f, 1.0f, 0, 0, "TestImage.jpg", "IMAGE_01"); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=0

            // print image with the ID specified
            Image_Print(3.0f, 0.2f, "IMAGE_01");
            Image_Print(1.0f, 0.2f, "IMAGE_01");
            PrintBox(1.1f, 0.25f, 2, 3.9f, 1.2f);
            PrintLabel(1, 1, 0);

            PortClose();


            //===== Second time to print image wit ID-sting
            if (!PortOpen(acPortBuffer))
            {
                MessageBox.Show("Can't open port!");
                return;
            }

            // print image with the ID specified
            Image_Print(0.0f, 0.2f, "IMAGE_01");
            Image_Print(2.0f, 0.2f, "IMAGE_01");
            PrintBox(0.1f, 0.25f, 2, 2.9f, 1.2f);
            PrintLabel(1, 1, 0);

            // delete image with the ID specified
            Image_Delete("IMAGE_01");

            PortClose();
        }

        private void But_Line_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        SetMeasurement(0, 0); // dots
	        PrintLine(50, 100, 200, 5, 0); // Black Line
	        PrintLine(100, 50, 5, 200, 0); // Black Line
	        PrintLine(150, 50, 5, 200, 1); // White Line
	        PrintLine(200, 50, 5, 200, 2); // Exclusive OR Line
	        PrintLabel(1, 1, 0);
	        PortClose();
        }

        private void But_Box_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        SetMeasurement(1, 0); // inchs
	        PrintBox(0.5f, 0.5f, 12, 1.0f, 1.0f); // (0.5, 0.5) to (1, 1) inch with 12 dots thickness
	        PrintLabel(1, 1, 0);
	        PortClose();
        }

        private void But_Demand_CalTest_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        DemandCalibrationTest(); // demand the printer to run a calibration test.
	        PortClose();
	        MessageBox.Show("Finish DemandCalibrationTest");
        }

        private void But_Demand_FacDef_Click(object sender, EventArgs e)
        {
        	StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        DemandFactoryDefaults(); // demand the printer to make itself to be factory defaults.
	        PortClose();
	        MessageBox.Show("Finish DemandFactoryDefaults");
        }

        private void But_Demand_LabFeed_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        DemandLabelFeed(); // demand the printer to feed out a blank label.
	        PortClose();
	        MessageBox.Show("Finish DemandLabelFeed");
        }

        private void But_Demand_PrnCon_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        DemandPrintConfiguration(); // demand the printer to print out a label with printer configuration.
	        PortClose();
	        MessageBox.Show("Finish DemandPrintConfiguration");
        }

        private void But_BarDrawerLaunch_Click(object sender, EventArgs e)
        {
            int nType = 1;
            int nSaveInfos = 1;
            string pstrFilePath = @"C:\Mandy\[SBARCO 條碼機(RP100)]\RP-100_TEST\SBARCO_SDK\SBARCO_SDK\Excel database.xls";
            string pstrUserName = "Admin";
            string pstrPassword = "";
            string pstrTable = "Sheet1$";

            BarDrawer_DatabaseSet(nType, nSaveInfos, pstrFilePath, pstrUserName, pstrPassword, pstrTable);
            //BarDrawer_DatabaseSet(1 /*Excel*/, TRUE, "Excel database.xls", "Admin", "", "Sheet1$");
            BarDrawer_Launch("DLLTest.bdw");
            //BarDrawer_LaunchNew("Sample1.bdw");
        }

        private void But_Setting_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        SetMeasurement(0, 0); // nMeasurement=0(Dots), 1(Inches), 2(Centimeters), 3(Millimeters); nResolution=0(Currecnt Set)
	        SetMedia_Continuous(800, 600, 20); // W=4 inch, H=3Inch, StopOffset=0.1 inch;
	        SetMedia_LabelWithGaps(800, 600, 32, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	        SetMedia_LabelWithMarks(800, 600, 40, 0);
	        SetPrinter(3, 10, 1); // nSpeed=3, nDarkness=10, bDirectThermal=1;
            SetReferencePoint(0, 0); // Set X and Y axis to 0 dot.
            SetTPH_YOffset(0); // Set Y offset of TPH to 0 dot.

	        SetAfterPrint (1, 0); // Enable Tear-Off mode after printing.
	        SetFontCharacterSet(7, 0); // 7 Bit Data with USA character Set
	        PrintLabel(0, 0, 0); // Only send data to printer without printing

	        PortClose();
        }

        private void But_Getting_Click(object sender, EventArgs e)
        {
            StringBuilder strTemp = new StringBuilder("");
            string stringTemp = "";

	        //PortOpen("COM1"); // not for LPT port
	        //PortSetupSerial(115200, 8, 0, 1, 1); // 115200 bps, 8 data-bits, no parity, 1 stop bit, hardware flowing control.

	        StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }
        	
	        //////////////////////////////////////////////////////////
	        //'''' Get Printer Emulation
	        if(GetEmulationType() == 100)
		        MessageBox.Show("PEPL Emulation");
	        else
		        MessageBox.Show("Can't get emulation from printer");

	        //////////////////////////////////////////////////////////
	        //'''' Get Printer Firmware Version
	        StringBuilder acBuffer = new StringBuilder("");
	        GetFirmwareVersion(acBuffer);
	        strTemp = acBuffer;
	        MessageBox.Show(strTemp.ToString());

	        //////////////////////////////////////////////////////////
	        //'''' Get Printed Distance
	        int nDistanceDots = GetPrintDistance(0); // Dots
	        int nDistanceInchs = GetPrintDistance(1); // inchs
	        int nDistanceCm = GetPrintDistance(2); // CentiMeters
	        int nDistanceMm = GetPrintDistance(3); // Millimeters
            stringTemp = nDistanceDots.ToString() + " dots, " + nDistanceInchs.ToString() + " inchs, " + nDistanceCm.ToString() + " cm, " + nDistanceMm.ToString() + " mm, " + (nDistanceCm / 100 / 1000).ToString() + " km";
	        MessageBox.Show(stringTemp);

	        //////////////////////////////////////////////////////////
	        //'''' Get Current Status
	        int nErrorCode = GetPrinterStatus();
	        if( nErrorCode != 0)
		        stringTemp = "Printr Status: Error Code " + nErrorCode;
	        else
                stringTemp = "Printr Status: Ready";
	        MessageBox.Show(stringTemp);

	        //////////////////////////////////////////////////////////
	        //'''' Get Printer Resolution
	        int nResolution = GetResolution();
	        stringTemp = nResolution + " dpi";
	        MessageBox.Show(stringTemp);

	        //////////////////////////////////////////////////////////
	        //'''' Get Printer Serial Number
	        if(GetSerialNumber(acBuffer) > 0)
	        {
		        stringTemp = "Serial Number: ";
		        stringTemp += acBuffer;
		        MessageBox.Show(stringTemp);
	        }
	        else
		        MessageBox.Show("Can't get serial number");

            //////////////////////////////////////////////////////////
            //'''' Get Reference Point
            int nAxisX = GetReferencePoint(0); // Get X axis in dot.
            int nAxisY = GetReferencePoint(1); // Get Y axis in dot.
            stringTemp = "X axis = " + nAxisX + ",  Y axis = " + nAxisY + "  (dots)";
            MessageBox.Show(stringTemp);

            //////////////////////////////////////////////////////////
            //'''' Get TPH Y Offset
            int nTphY = GetTPH_YOffset(); // Get TPH Y offset in dot.
            stringTemp = "TPH Y Offset = " + nTphY + " (dots)";
            MessageBox.Show(stringTemp);


	        PortClose();
        }

        private void But_AboutDLL_Click(object sender, EventArgs e)
        {
            double dbVersion = DllAbout(1); // 1=display dialog, 0=only return version

            string strVersion = "";

            strVersion  = "DLL Version: " + dbVersion.ToString();
            MessageBox.Show(strVersion);
        }

        private void But_AboutSolution_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Solution_CShap Version: 1.9", "Solution CShap");
        }

        private void But_SendCommands1_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");

            //char acData[] = "\r\nZT\r\nB200,200,0,3,1,2,60,B,\"12345\"\r\nP1\r\n";
            StringBuilder acData = new StringBuilder("");
            acData.Append("\r\nZT\r\nB200,200,0,3,1,2,60,B,\"test\"\r\nP1\r\n");
            //= "ZT B200,200,0,3,1,2,60,B,\"12345\"P1";

	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        int nDataLen = acData.Length;
	        if(nDataLen != SendCmd(nDataLen, acData))
		        MessageBox.Show("The data length is not correct.");

	        PortClose();
        }

        private void But_SendCommands2_Click(object sender, EventArgs e)
        {
            int nPortCount =  PortEnumCount(0); // Get USB count
            StringBuilder acPortBuffer = new StringBuilder("");

            PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port

            if (!PortOpen(acPortBuffer))
            {
                MessageBox.Show("Can't open port!","Solution C#");
            }
            
            
            int nSendLen = SendCmd(-1, null);
            string strMessage = "";

            strMessage = "Data length = " + nSendLen.ToString();
            MessageBox.Show(strMessage, "Solution C#");

            PortClose();
        }

        private void But_SendFile1_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }

	        int nDataLen = SendFileA("testcmd.txt");
	        //int nDataLen = SendFileW(_T("testcmd.txt"));
        	
	        string strMessage;
	        strMessage = "Data length = " + nDataLen.ToString();
	        MessageBox.Show(strMessage);

	        PortClose();
        }

        private void But_SendFile2_Click(object sender, EventArgs e)
        {
            StringBuilder acPortBuffer = new StringBuilder("");
	        int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        //if(PortOpen("\\\\TESTPC\\SbarcoT4-usb02") == 0)
	        {
		        MessageBox.Show("Can't open port!");
		        return;
	        }
        	
	        int nDataLen = SendFileA("open");
	        //int nDataLen = SendFileW(_T("open"));
        	
	        string strMessage;
	        strMessage = "Data length = " + nDataLen.ToString();
	        MessageBox.Show(strMessage);

	        PortClose();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int nPortCount = PortEnumCount(0); // Get USB count
            StringBuilder acPortBuffer = new StringBuilder("");
            PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
            if (!PortOpen(acPortBuffer))
            {
                MessageBox.Show("Can't open port!");
                return;
            }

            SetMeasurement(3, 0); // mm
            SetMedia_LabelWithGaps(65, 40, 32, 0); // W=65, H=40 (mm), GapLen=32 dots, GapOffset=0

            //===== Draw a box on label
            PrintBox(0, 0, 1, 65, 40); //(0, 0) to (65, 40) mm with 1 dots thickness

            //===== Print out some text and barcode on label
            // Page 1
            string strData = "-張豐盛行花生醬-";
            PrintTTF_AlignmentA(0.0f, 6.6f,  65.0f, 1, 21, -1, 0, 0, 0, 0, "標楷體", strData);
            strData = "25元";
            PrintTTF_AlignmentA(0.0f, 16.9f, 65.0f, 1, 28, -1, 0, 0, 0, 0, "標楷體", strData);
            strData = "123456789012";
            int nStrLen = strData.Length;
            PrintBarcode(18.5f, 27.8f, 9.0f, 0, 14, 2, 4, 1, nStrLen, strData);
            PrintLabel(1, 1, 0);

            // Page 2
            strData = "-冬蟲夏草-";
            PrintTTF_AlignmentA(0.0f, 6.6f, 65.0f, 1, 21, -1, 0, 0, 0, 0, "標楷體", strData);
            strData = "2999元";
            PrintTTF_AlignmentA(0.0f, 16.9f, 65.0f, 1, 28, -1, 0, 0, 0, 0, "標楷體", strData);
            strData = "987654321043";
            nStrLen = strData.Length;
            PrintBarcode(18.5f, 27.8f, 9.0f, 0, 14, 2, 4, 1, nStrLen, strData);
            PrintLabel(1, 1, 0);



            PortClose();

        }

        private void But_FormTest_Click(object sender, EventArgs e)
        {
            string FORM_NAME = "TRUNCATION";
            string FORM_PARAMETER1 = "FF12345678";
            string FORM_PARAMETER2 = "RR87654321";
            StringBuilder acPortBuffer = new StringBuilder("");

            int nPortCount = PortEnumCount(0); // Get USB count
	        PortEnumGet(0, 0, acPortBuffer); // Get name of number 0 of USB port
	        if(!PortOpen(acPortBuffer))
	        //if(PortOpen("c:\\testfile.txt") == 0)
	        {
                MessageBox.Show("Can't open port!");
		        return;
	        }
            	

	            //===== Send form file to printer
	            if(!FormCheck("TRUNCATION"))
	            {
		            int nDataLen = FormSaveByFileA("Sample_Truncation_Form.prn");
		            if(nDataLen == 0)
		            {
                        MessageBox.Show("Can't open file!");
			            PortClose();
			            return;
		            }
	            }
            	

	            //===== Send Parameter Data to printer
	            FormExecute(FORM_NAME); // Send command to printer to execute form by form name "TRUNCATION".
	            FormParameterData(FORM_PARAMETER1);
	            FormParameterData(FORM_PARAMETER2);
	            FormPrint(1,1);
	            PortClose();


                MessageBox.Show("--- Test End ---");
        }

        private void But_Commands_Parser_Click(object sender, EventArgs e)
        {
            //CmdParser("C:\\Temp.txt");
            string strString = "C:\\Documents and Settings\\Administrator\\My Documents\\Temp.txt";
            CmdParserA("open");
        }

        


    }
}
