unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ButPrintText: TButton;
    GroupBox1: TGroupBox;
    PrintTrueTypeFont: TButton;
    ButPrintDataMatrix: TButton;
    ButPrintPDF417: TButton;
    ButPrintBarcode: TButton;
    ButPrintMaxiCode: TButton;
    ButPrintImage: TButton;
    ButPrintLine: TButton;
    ButPrintBox: TButton;
    ButSendCommands1: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    Label1: TLabel;
    ButSendCommands2: TButton;
    ButSendFile1: TButton;
    ButSendFile2: TButton;
    ButDemandCalibrationTest: TButton;
    ButDemandFactoryDefaults: TButton;
    ButDemandLabelFeed: TButton;
    ButDemandPrintConfiguration: TButton;
    ButBarDrawerLaunch: TButton;
    ButSendtoUSB: TButton;
    ButSendtoEthernet: TButton;
    ButSendtoLPT: TButton;
    ButSendtoRS232: TButton;
    ButSetRS232Port: TButton;
    ButSetting: TButton;
    ButGetting: TButton;
    ButAboutDLL: TButton;
    ButAboutSolutionDelphi: TButton;
    ButFormTest: TButton;
    ButTest2: TButton;
    Button1: TButton;
    ButPrintTTF_Alignment: TButton;
    ButPrintParagraph: TButton;
    ButPrintQRCode: TButton;
    procedure ButPrintTextClick(Sender: TObject);
    procedure PrintTrueTypeFontClick(Sender: TObject);
    procedure ButPrintBarcodeClick(Sender: TObject);
    procedure ButPrintPDF417Click(Sender: TObject);
    procedure ButPrintDataMatrixClick(Sender: TObject);
    procedure ButPrintMaxiCodeClick(Sender: TObject);
    procedure ButPrintImageClick(Sender: TObject);
    procedure ButPrintLineClick(Sender: TObject);
    procedure ButPrintBoxClick(Sender: TObject);
    procedure ButSendCommands1Click(Sender: TObject);
    procedure ButSendCommands2Click(Sender: TObject);
    procedure ButSendFile1Click(Sender: TObject);
    procedure ButSendFile2Click(Sender: TObject);
    procedure ButDemandCalibrationTestClick(Sender: TObject);
    procedure ButDemandFactoryDefaultsClick(Sender: TObject);
    procedure ButDemandLabelFeedClick(Sender: TObject);
    procedure ButDemandPrintConfigurationClick(Sender: TObject);
    procedure ButBarDrawerLaunchClick(Sender: TObject);
    procedure ButSendtoUSBClick(Sender: TObject);
    procedure ButSendtoEthernetClick(Sender: TObject);
    procedure ButSendtoLPTClick(Sender: TObject);
    procedure ButSendtoRS232Click(Sender: TObject);
    procedure ButSetRS232PortClick(Sender: TObject);
    procedure ButSettingClick(Sender: TObject);
    procedure ButGettingClick(Sender: TObject);
    procedure ButAboutDLLClick(Sender: TObject);
    procedure ButAboutSolutionDelphiClick(Sender: TObject);
    procedure ButFormTestClick(Sender: TObject);
    procedure ButTest2Click(Sender: TObject);
    procedure ButtonSavePrintImageClick(Sender: TObject);
    procedure ButPrintTTF_AlignmentClick(Sender: TObject);
    procedure ButPrintParagraphClick(Sender: TObject);
    procedure ButPrintQRCodeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Solution_Delphi Unit.dfm - Delphi Sample for SBARCO API DLL
''
'' Copyright (C) Sbarco Co. Ltd. 2010 - 2012  All rights reserved.
''
'' History - 2010/08/09 Ver:1.0 - First Release
''           2010/11/11 Ver:1.1 - Add BarDrawer Functions
''           2010/11/23 Ver:1.2 - Remove the rectangle of PrintImage function. The rectangle is for debuging.
''           2011/05/26 Ver:1.4 - Fixed bug for Tear-Off Mode of SetAfterPrint Function.
''           2011/06/09 Ver:1.5 - Function of PortOpen added an option of name pipe for sharing printer.
''           2011/07/04 Ver:1.6 - Add function for SetReferencePoint, GetReferencePoint.
''           2011/07/25 Ver:1.7 - Modify TPH width from 200 to 203 dpi.
''                              - Fixed USB enum bug for one of longer USB register name.
''                              - Add function for Y offset of TPH.
''           2011/08/31 Ver:1.8 - Add Form Functions for FormSaveByFileA, FormSaveByFileW, FormCheck, FormExecute,
''                              - FormParameterData and FormPrint.
''                              - Add a FormTest sample in VC and VB.
''           2011/09/08 Ver:1.9 - Add Ethernet communication for PortEnumCount(), PortEnumGet() and PortOpen() Functions.
''           2011/10/03 Ver:1.10 - Add Delphi Sample Codes.
''                               - Fixed GetPrintDistance() bug in Dot Mode.
''                               - Change the DllAbout() return value from integer to double.
''           2011/12/08 Ver:1.11 - OpenPort() removed the query action.
''                               - PrintLabel() add a command for saving data to RAM.
''                               - When the print fails, the program automatically clears the memory of the print content.
''                               - If the program execution path exists file "DLLTOFILE.txt", the program will automatically print the contents to "DLLTOFILE.txt".
''                               - Add ImageSave(), ImagePrint(), ImageDelete() functions for not storing image for many times.
''           2012/02/13 Ver:1.12 - Add PrintTTF_AlignmentA, PrintTTF_AlignmentW for True Type Font Text with horizontal alignment.
''                                 Add PrintParagraphA, PrintParagraphW for True Type Font paragraph with horizontal alignement.
''                                 Add PrintQRcode for QR code.
''                                 Add CShap Sample Codes.
''}

{Port Function}
	function PortOpen (pPortName:pchar):integer;stdcall;external 'SBSDK_API.DLL';
	Procedure PortClose ();stdcall;external 'SBSDK_API.DLL';
	function PortEnumCount (nPortType:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function PortEnumGet (nPortType:integer; nItem:integer; pBuffer:Pchar):integer;stdcall;external 'SBSDK_API.DLL';
	function PortSetupSerial (nBaudRate:integer; nDataBits:integer; nParity:integer; nStopBits:integer; nFlowControl:integer):integer;stdcall;external 'SBSDK_API.DLL';
{Setting Function}
	function SetAfterPrint (nType:integer; nCutPiece:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function SetFontCharacterSet (nNumberBit:integer; nCharacterSet:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function SetMeasurement (nMeasurement:integer; nResolution:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function SetMedia_Continuous (fLabelWidth:Single; fLabelLen:Single; fStopOffset:Single):integer;stdcall;external 'SBSDK_API.DLL';
	function SetMedia_LabelWithGaps (nLabelWidth:Single; nLabelLen:Single; nGapLen:Single; nGapOffset:Single):integer;stdcall;external 'SBSDK_API.DLL';
	function SetMedia_LabelWithMarks (fLabelWidth:Single; fLabelLen:Single; fBlackLineLen:Single; fThicknessOffset:Single):integer;stdcall;external 'SBSDK_API.DLL';
	function SetPrinter (nSpeed:integer; nDarkness:integer; bDirectThermal:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function SetReferencePoint (nHoriDot:integer; nVertDot:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function SetTPH_YOffset (nOffsetDot:integer):integer;stdcall;external 'SBSDK_API.DLL';
{Print Function}
	function PrintText (fX:Single; fY:Single; nRotation:integer; nFontID:integer; nFontHor:integer; nFontVer:integer; bReverse:integer; nDataLen:integer; pData:string):integer;stdcall;external 'SBSDK_API.DLL';
	function PrintBarcode (fX:Single; fY:Single; fBarHeight:Single; nRotation:integer; nBarType:integer; nNarrowBar:integer; nWideBar:integer; bHuman:integer; nDataLen:integer; pData:string):integer;stdcall;external 'SBSDK_API.DLL';
	function PrintPDF417 (fX:Single; fY:Single; nRotation:integer; nCorrectionLevel:integer; bCompression:integer; nModuleWidth:integer; nBarHeight:integer; nMaxColumns:integer; nMaxRows:integer; nTruncated:integer; nDataLen:integer; pData:string):integer;stdcall;external 'SBSDK_API.DLL';
	function PrintDataMatrix (fX:Single; fY:Single; nRotation:integer; nColumns:integer; nRows:integer; nSquare:integer; bInverseImage:integer; nDataLen:integer; pData:string):integer;stdcall;external 'SBSDK_API.DLL';
	function PrintMaxiCode (fX:Single; fY:Single; nRotation:integer; nMode:integer; nDataLen:integer; pData:string):integer;stdcall;external 'SBSDK_API.DLL';
        function PrintQRcode (fX:Single; fY:Single; nRotation:integer; nErrorCorrection:integer; nModel:integer; nMaskNumber:integer; nPixel:integer; nDataLen:integer; pData:string):integer;stdcall;external 'SBSDK_API.DLL';
        function PrintLine (fX:Single; fY:Single; fHoriLength:Single; fVertLength:Single; nDrawMethod:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function PrintBox (fX1:Single; fY1:Single; nThickness:integer; fX2:Single; fY2:Single):integer;stdcall;external 'SBSDK_API.DLL';
	function PrintImage (fX:Single; fY:Single; fWidth:Single; fHeight:Single; nRotation:integer; bErrorDiffusion:integer; pFileName:string):integer;stdcall;external 'SBSDK_API.DLL';
	function PrintTrueTypeFontA (fX:Single; fY:Single; nFontH:integer; nFontW:integer; nRotation:integer; nStyle:integer; bUnderline:integer; bWhitOnBlack:integer; pFaceName:string; pText:string):integer;stdcall;external 'SBSDK_API.DLL';
       	function PrintTrueTypeFontW (fX:Single; fY:Single; nFontH:integer; nFontW:integer; nRotation:integer; nStyle:integer; bUnderline:integer; bWhitOnBlack:integer; pFaceName:WideString; pText:WideString):integer;stdcall;external 'SBSDK_API.DLL';
        function PrintTTF_AlignmentA (fX:Single; fY:Single; fRangeWidth:Single; nAlignment:integer; nFontH:integer; nFontW:integer; nRotation:integer; nStyle:integer; bUnderline:integer; bWhitOnBlack:integer; pFaceName:string; pText:string):integer;stdcall;external 'SBSDK_API.DLL';
       	function PrintTTF_AlignmentW (fX:Single; fY:Single; fRangeWidth:Single; nAlignment:integer; nFontH:integer; nFontW:integer; nRotation:integer; nStyle:integer; bUnderline:integer; bWhitOnBlack:integer; pFaceName:WideString; pText:WideString):integer;stdcall;external 'SBSDK_API.DLL';
        function PrintParagraphA (fX:Single; fY:Single; fRangeWidth:Single; nAlignment:integer; nFontH:integer; nFontW:integer; nRotation:integer; nStyle:integer; bUnderline:integer; bWhitOnBlack:integer; pFaceName:string; pText:string):integer;stdcall;external 'SBSDK_API.DLL';
       	function PrintParagraphW (fX:Single; fY:Single; fRangeWidth:Single; nAlignment:integer; nFontH:integer; nFontW:integer; nRotation:integer; nStyle:integer; bUnderline:integer; bWhitOnBlack:integer; pFaceName:WideString; pText:WideString):integer;stdcall;external 'SBSDK_API.DLL';
        function PrintLabel (nSet:integer; nCopy:integer; bReverse:integer):integer;stdcall;external 'SBSDK_API.DLL';
        function Image_Save (fWidth:Single; fHeight:Single; nRotation:integer; bErrorDiffusion:integer; pFileName:string; pIDString:string):integer;stdcall;external 'SBSDK_API.DLL';
        function Image_Print (fX:Single; fY:Single; pIDString:string):integer;stdcall;external 'SBSDK_API.DLL';
        function Image_Delete (pIDString:string):integer;stdcall;external 'SBSDK_API.DLL';
{Form Function}
        function FormSaveByFileA (pFileName:string):integer;stdcall;external 'SBSDK_API.DLL';
        function FormSaveByFileW (ptcFileName:WideString):integer;stdcall;external 'SBSDK_API.DLL';
        function FormCheck (pFormName:string):integer;stdcall;external 'SBSDK_API.DLL';
        function FormExecute (pFormName:string):integer;stdcall;external 'SBSDK_API.DLL';
        function FormParameterData (pData:string):integer;stdcall;external 'SBSDK_API.DLL';
        function FormPrint (nSet:integer; nCopy:integer):integer;stdcall;external 'SBSDK_API.DLL';
{Demand Functions}
	Procedure DemandCalibrationTest ();stdcall;external 'SBSDK_API.DLL';
	Procedure DemandFactoryDefaults ();stdcall;external 'SBSDK_API.DLL';
	Procedure DemandLabelFeed ();stdcall;external 'SBSDK_API.DLL';
	Procedure DemandPrintConfiguration ();stdcall;external 'SBSDK_API.DLL';
	Procedure DemandResetPrinter ();stdcall;external 'SBSDK_API.DLL';
{Getting Functions}
	function GetEmulationType ():integer;stdcall;external 'SBSDK_API.DLL';
	function GetFirmwareVersion (pBuffer:pchar):integer;stdcall;external 'SBSDK_API.DLL';
	function GetPrintDistance (nMeasurement:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function GetPrinterStatus ():integer;stdcall;external 'SBSDK_API.DLL';
	function GetReferencePoint (nAxisType:integer):integer;stdcall;external 'SBSDK_API.DLL';
	function GetResolution ():integer;stdcall;external 'SBSDK_API.DLL';
	function GetSerialNumber (pBuffer:pchar):integer;stdcall;external 'SBSDK_API.DLL';
	function GetTPH_YOffset ():integer;stdcall;external 'SBSDK_API.DLL';
{Other Functions}
	function DllAbout (bDisplay:integer):Single;stdcall;external 'SBSDK_API.DLL';
	function SendCmd (nDataLen:integer; lpData:string):integer;stdcall;external 'SBSDK_API.DLL';
	function SendFileA (pFileName:string):integer;stdcall;external 'SBSDK_API.DLL';
        function SendFileW (ptcFileName: WideString):integer;stdcall;external 'SBSDK_API.DLL';
{BarDrawer Functions}
	function BarDrawer_DatabaseSet (nType:integer; nSaveInfos:integer; pstrFilePath:string; pstrUserName:string; pstrPassword:string; pstrTable:string):integer;stdcall;external 'SBSDK_API.DLL';
	function BarDrawer_Launch (pFileName:string):integer;stdcall;external 'SBSDK_API.DLL';
	function BarDrawer_LaunchNew (pFileName:string):integer;stdcall;external 'SBSDK_API.DLL';


procedure TForm1.ButPrintTextClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4.0, 3.0, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult := PrintText(2.0, 1.5, 0, 2, 1, 1, 0, 8, 'AaBbCcDd'); // X=2.0, Y=1.5 (inches), No rotation, Font2, Hor Expand=1, Ver Expand=1, normal image
	bResult := PrintText(2.0, 1.5, 1, 2, 1, 1, 0, 8, 'AaBbCcDd'); // X=2.0, Y=1.5 (inches), 90 rotation, Font2, Hor Expand=1, Ver Expand=1, normal image
	bResult := PrintText(2.0, 1.5, 2, 2, 1, 1, 0, 8, 'AaBbCcDd'); // X=2.0, Y=1.5 (inches), 180 rotation, Font2, Hor Expand=1, Ver Expand=1, normal image
	bResult := PrintText(2.0, 1.5, 3, 2, 1, 1, 0, 8, 'AaBbCcDd'); // X=2.0, Y=1.5 (inches), 270 rotation, Font2, Hor Expand=1, Ver Expand=1, normal image

        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.PrintTrueTypeFontClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    TStr: WideString;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4.0, 3.0, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult := PrintTrueTypeFontA(1.0, 1.0, 12, -1, 0, 3, 0, 1, 'Times New Roman', 'AaBbCcDd'); // nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=1
        TStr := WideString(#$53) + WideString(#$42) + WideString(#$41) + WideString(#$52) + WideString(#$43) + WideString(#$4F) + WideString(#$5370) + WideString(#$8868) + WideString(#$6A5F) + WideString(#$53) + WideString(#$44) + WideString(#$4B);
        bResult := PrintTrueTypeFontW(2.0, 2.0, 12, -1, 0, 3, 1, 0, 'Times New Roman', TStr); //nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=1, bWhitOnBlack=0

        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButPrintBarcodeClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4, 3, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult := PrintBarcode(2.0, 1.5, 0.3, 0, 1, 2, 4, 1, 5, '12345'); //fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl
	bResult := PrintBarcode(2.0, 1.5, 0.3, 1, 1, 2, 4, 1, 5, '12345'); //fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl
	bResult := PrintBarcode(2.0, 1.5, 0.3, 2, 1, 2, 4, 1, 5, '12345'); //fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl
	bResult := PrintBarcode(2.0, 1.5, 0.3, 3, 1, 2, 4, 1, 5, '12345'); //fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl

        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);

end;

procedure TForm1.ButPrintPDF417Click(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    nDataLen, nMaxRows, nBarHeight, bCompression, nCorrectionLevel, nModuleWidth, nMaxColumns, nTruncated: Integer;
    pData:string;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        nCorrectionLevel := 1;
	bCompression := 0;
	nModuleWidth := 2;
	nBarHeight := 4;
	nMaxColumns := 1;
	nMaxRows := 10;
	nTruncated := 0;
	nDataLen := 5;
	pData := '12345';

        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4.0, 3.0, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

	bResult := PrintPDF417(2.0, 1.5, 0, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData);
	bResult := PrintPDF417(2.0, 1.5, 1, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData);
	bResult := PrintPDF417(2.0, 1.5, 2, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData);
	bResult := PrintPDF417(2.0, 1.5, 3, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData);
	bResult := PrintBox(1.15, 0.65, 2, 2.9, 2.4);

        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButPrintDataMatrixClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    nDataLen, nSquare, nColumns, nRotation, nRows, bInverseImage: Integer;
    pData: string;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        nRotation := 0;
	nColumns := 10;
	nRows := 10;
	nSquare := 4;
	bInverseImage := 0;
	nDataLen := 5;
	pData := '12345';
        bResult := PrintDataMatrix(0.8, 0.8, nRotation, nColumns, nRows, nSquare, bInverseImage, nDataLen, pData);
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButPrintMaxiCodeClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    nDataLen, nRotation, nMode: Integer;
    pData: string;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        nRotation := 0;
	nMode := 0;
	pData := '300,840,93065,1692,This is MaxiCode,but not MaxiCode formatted data';
        nDataLen := Length(pData);
        bResult := PrintMaxiCode(0.8, 0.8, nRotation, nMode, nDataLen, pData);
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButPrintImageClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4, 3, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult := PrintImage(2.0, 1.5, 1.0, 1.5, 0, 1, 'TestImage.jpg'); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
	bResult := PrintImage(2.0, 1.5, 1.0, 1.5, 1, 1, 'TestImage.jpg'); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
	bResult := PrintImage(2.0, 1.5, 1.0, 1.5, 2, 1, 'TestImage.jpg'); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
	bResult := PrintImage(2.0, 1.5, 1.0, 1.5, 3, 1, 'TestImage.jpg'); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
	bResult := PrintBox(0.55, 0.05, 2, 3.45, 2.95);

        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButtonSavePrintImageClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4, 3, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

        // save image with the ID specified
	bResult := Image_Save(1.0, 1.0, 0, 0, 'TestImage.jpg', 'IMAGE_01'); // nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=0

	// print image with the ID specified
	bResult := Image_Print(3.0, 0.2, 'IMAGE_01');
	bResult := Image_Print(1.0, 0.2, 'IMAGE_01');
        bResult := PrintBox(1.1, 0.25, 2, 3.9, 1.2);
	bResult := PrintLabel(1, 1, 0);

	PortClose();


	//===== Second time to print image wit ID-sting
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;

	// print image with the ID specified
	bResult := Image_Print(0.0, 0.2, 'IMAGE_01');
	bResult := Image_Print(2.0, 0.2, 'IMAGE_01');
        bResult := PrintBox(0.1, 0.25, 2, 2.9, 1.2);
	bResult := PrintLabel(1, 1, 0);

	// delete image with the ID specified
	bResult := Image_Delete('IMAGE_01');

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);

end;

procedure TForm1.ButPrintLineClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(0, 0); // dots
        bResult := PrintLine(50, 100, 200, 5, 0); //Black Line
        bResult := PrintLine(100, 50, 5, 200, 0); //Black Line
        bResult := PrintLine(150, 50, 5, 200, 1); //White Line
        bResult := PrintLine(200, 50, 5, 200, 2); //Exclusive OR Line
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButPrintBoxClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        bResult := PrintBox(0.5, 0.5, 12, 1, 1); //(0.5, 0.5) to (1, 1) inch with 12 dots thickness
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButSendCommands1Click(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    nDataLen, nSendLen: Integer;
    acData: string;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        acData := Chr(13) + Chr(10) + 'ZT' + Chr(13) + Chr(10) + 'B200,200,0,3,1,2,60,B,' + Chr(34) + '12345' + Chr(34) + Chr(13) + Chr(10) + 'P1' + Chr(13) + Chr(10);

        nDataLen := Length(acData);
        nSendLen := SendCmd(nDataLen, acData);
	If nDataLen <> nSendLen Then bResult := messagebox(0, 'The data length is not correct.', 'Solution Delphi', MB_ICONERROR);

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButSendCommands2Click(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    nSendLen: Integer;
    strMessage, acData: string;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        nSendLen := SendCmd(-1, acData);
        strMessage := 'Data length = ' + IntToStr(nSendLen);
        bResult := messagebox(0, PChar(strMessage), 'Solution Delphi', MB_OK);

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButSendFile1Click(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    nSendLen: Integer;
    strMessage: string;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        nSendLen := SendFileA('testcmd.txt');
        strMessage := 'Data length = ' + IntToStr(nSendLen);
        bResult := messagebox(0, PChar(strMessage), 'Solution Delphi', MB_OK);

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButSendFile2Click(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    nSendLen: Integer;
    strMessage: string;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        nSendLen := SendFileA('open');
        strMessage := 'Data length = ' + IntToStr(nSendLen);
        bResult := messagebox(0, PChar(strMessage), 'Solution Delphi', MB_OK);

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButDemandCalibrationTestClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        DemandCalibrationTest(); //demand the printer to run a calibration test.

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButDemandFactoryDefaultsClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        DemandFactoryDefaults(); //demand the printer to make itself to be factory defaults.

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButDemandLabelFeedClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        DemandLabelFeed(); //demand the printer to feed out a blank label.

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButDemandPrintConfigurationClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        DemandPrintConfiguration(); //demand the printer to print out a label with printer configuration.

        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButBarDrawerLaunchClick(Sender: TObject);
var
    bResult, nType, nSaveInfos: Integer;
    pstrFilePath, pstrUserName, pstrPassword, pstrTable: string;
begin
        //Launch BarDrawer with database setting or new a label file
        nType := 1;
        nSaveInfos := 1;
        pstrFilePath := 'Excel database.xls';
        pstrUserName := 'Admin';
        pstrPassword := '';
        pstrTable := 'Sheet1$';

        bResult := BarDrawer_DatabaseSet(nType, nSaveInfos, pstrFilePath, pstrUserName, pstrPassword, pstrTable);
        //bResult = BarDrawer_DatabaseSet(1, 1, 'Excel database.xls', 'Admin', '', 'Sheet1$');
        bResult := BarDrawer_Launch('DLLTest.bdw');
        //bResult = BarDrawer_LaunchNew('Sample1.bdw');

        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
end;

procedure TForm1.ButSendtoUSBClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        bResult := PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 14, 'Print from USB');
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButSendtoEthernetClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open Ethernet port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(3); { Get Ethernet count}
        bResult := PortEnumGet(3, 0, acPortBuffer);  {Get name of number 0 of Ethernet port}
        bResult := PortOpen(acPortBuffer);
        //bResult := PortOpen('192.168.1.20');
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        bResult := PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 14, 'Print from Ethernet');
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButSendtoLPTClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open LPT port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(2); { Get LPT count}
        bResult := PortEnumGet(2, 0, acPortBuffer);  {Get name of number 0 of LPT port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        bResult := PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 14, 'Print from LPT');
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButSendtoRS232Click(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open RS232 port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(1); { Get RS232 count}
        bResult := PortEnumGet(1, 0, acPortBuffer);  {Get name of number 0 of RS232 port}
        bResult := PortSetupSerial(115200, 8, 0, 1, 1); // 115200 bps, 8 data-bits, no parity, 1 stop bit, hardware flowing control.
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        bResult := PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 14, 'Print from RS232');
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButSetRS232PortClick(Sender: TObject);
var
    bResult: Integer;
begin
        //Open RS232 port
        bResult := PortSetupSerial(115200, 8, 0, 1, 1); // 115200 bps, 8 data-bits, no parity, 1 stop bit, hardware flowing control.
        bResult := PortOpen('COM1');
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        bResult := PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 14, 'Print from RS232');
        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
end;

procedure TForm1.ButSettingClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
        bResult := SetMedia_Continuous(4, 3, 0.1); // W=4 inch, H=3Inch, StopOffset=0.1 inch;

        bResult := SetMeasurement(0, 0) ; // Dot,  nMeasurement=0(Dots), 1(Inches), 2(Centimeters), 3(Millimeters); nResolution=0(Currecnt Set)
	bResult := SetMedia_LabelWithGaps(800, 600, 32, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;

	bResult := SetMeasurement(2, 0); // Centimeters,  nMeasurement=0(Dots), 1(Inches), 2(Centimeters), 3(Millimeters); nResolution=0(Currecnt Set)
	bResult := SetMedia_LabelWithMarks(10, 6, 0.4, 0);

	bResult := SetPrinter(3, 10, 1); // nSpeed=3, nDarkness=10, bDirectThermal=1;
	bResult := SetReferencePoint(0, 0); // Set X and Y axis to 0 dot.
	bResult := SetTPH_YOffset(0); // Set Y offset of TPH to 0 dot.

	bResult := SetAfterPrint(1, 0); // Enable Tear-Off mode after printing.
	bResult := SetFontCharacterSet(7, 0); // 7 Bit Data with USA character Set
        bResult := PrintLabel(0, 0, 0); // Only send data to printer without printing
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButGettingClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    acBuffer: Pchar;
    nDistanceDots, nDistanceInchs, nDistanceCm, nDistanceMm, nErrorCode, nResolution: Integer;
    nAxisX, nAxisY, nTphY: Integer;
    strMessage: String;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;

	acBuffer := PChar(AllocMem(80));

	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//'''' Get Printer Emulation
	If GetEmulationType() = 100
        Then begin
                bResult := messagebox(0, 'PEPL Emulation', 'Solution Delphi', MB_OK);
        end
        else begin
               	bResult := messagebox(0, 'Can not get emulation from printer', 'Solution Delphi', MB_ICONERROR);
	end;
		
	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//'''' Get Printer Firmware Version
	bResult := GetFirmwareVersion(acBuffer);
	bResult := messagebox(0, acBuffer, 'Solution Delphi', MB_OK);

	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//'''' Get Printed Distance
	nDistanceDots := GetPrintDistance(0); // Dots
	nDistanceInchs := GetPrintDistance(1); // inchs
	nDistanceCm := GetPrintDistance(2); // CentiMeters
	nDistanceMm := GetPrintDistance(3); // Millimeters
        strMessage := IntToStr(nDistanceDots) + ' dots, ' + IntToStr(nDistanceInchs) + ' inchs, ' + IntToStr(nDistanceCm) + ' cm, ' + IntToStr(nDistanceMm) + ' mm, ' + IntToStr((nDistanceCm div 100) div 1000) + ' km';
	bResult := messagebox(0, Pchar(strMessage), 'Solution Delphi', MB_OK);

	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//'''' Get Current Status
	nErrorCode := GetPrinterStatus();
	If nErrorCode = 0
        Then begin
		bResult := messagebox(0, 'Printr Status: Ready', 'Solution Delphi', MB_OK);
        end
	Else begin
		strMessage := 'Printr Status: Error Code ' +  IntToStr(nErrorCode);
		bResult := messagebox(0, Pchar(strMessage), 'Solution Delphi', MB_OK);
	end;


	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//'''' Get Printer Resolution
	nResolution := GetResolution();
	strMessage := IntToStr(nResolution) + ' dpi';
	bResult := messagebox(0, pchar(strMessage), 'Solution Delphi', MB_OK);

	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//'''' Get Printer Serial Number
        //Dim nBufLen As Integer
	If GetSerialNumber(acBuffer) > 0
        Then begin
		strMessage := 'Serial Number: ' + acBuffer;
		bResult := messagebox(0, pchar(strMessage), 'Solution Delphi', MB_OK);
        end
	else begin
		bResult := messagebox(0, 'Can not get serial number', 'Solution Delphi', MB_ICONERROR);
	End;

	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//'''' Get Reference Point
	nAxisX := GetReferencePoint(0); // Get X axis in dot.
	nAxisY := GetReferencePoint(1); // Get Y axis in dot.
	strMessage := 'X axis = ' + IntToStr(nAxisX) + ',  Y axis = ' + IntToStr(nAxisY) + '  (dots)';
	bResult := messagebox(0, pchar(strMessage), 'Solution Delphi', MB_OK);

	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//'''' Get TPH Y Offset
	nTphY := GetTPH_YOffset(); // Get TPH Y offset in dot.
	strMessage := 'TPH Y Offset = ' + IntToStr(nTphY) + '  (dots)';
	bResult := messagebox(0, pchar(strMessage), 'Solution Delphi', MB_OK);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
        FreeMem(acBuffer);
end;

procedure TForm1.ButAboutDLLClick(Sender: TObject);
var
    bResult: Integer;
    dbVersion: Double;
    strVersion: String;
begin
        dbVersion := DllAbout(1); // 1=display dialog, 0=only return version

        strVersion := 'DLL Version: ' + FloatToStr(dbVersion);
        bResult := messagebox(0, pchar(strVersion), 'Solution Delphi', MB_OK);
end;

procedure TForm1.ButAboutSolutionDelphiClick(Sender: TObject);
begin
        messagebox(0, 'Solution_Delphi Version: 1.8', 'Solution Delphi', MB_OK);
end;

procedure TForm1.ButFormTestClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount, nDataLen: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
       //===== Send form file to printer
        bResult := FormCheck('TRUNCATION');

        If bResult = 0
        Then begin
            nDataLen := FormSaveByFileA('Sample_Truncation_Form.prn'); // please get the file before testing
            If nDataLen = 0
            Then begin
                bResult := messagebox(0, 'Can not open file!', 'Solution Delphi', MB_ICONERROR);
                PortClose();
                Exit;
            end;
        end;

        //===== Send Parameter Data to printer
        FormExecute('TRUNCATION'); //Send command to printer to execute form by form name "TRUNCATION".
        FormParameterData('FF12345678');
        FormParameterData('RR87654321');
        FormPrint(1, 1);
        PortClose();

        bResult := messagebox(0, '--- Test End ---', 'Solution Delphi', MB_OK);
        FreeMem(acPortBuffer);
end;
procedure TForm1.ButTest2Click(Sender: TObject);
var
    bResult: Integer;
    nPortCount, nDataLen: Integer;
    acPortBuffer: Pchar;
    pData: Pchar;
    StrLen: Integer;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        //===== Set Measurment Unit and Label size
        bResult := SetMeasurement(3, 0); // mm
        bResult := SetMedia_LabelWithGaps(65, 40, 32, 0); // W=65, H=40 (mm), GapLen=32 dots, GapOffset=0

        //===== Draw a box on label
        bResult := PrintBox(0, 0, 1, 65, 40); //(0, 0) to (65, 40) mm with 1 dots thickness

        //===== Print out some text and barcode on label
        pData := '²˪GJ|]';
        bResult := PrintTrueTypeFontA(2.4, 3.2, 14, -1, 0, 0, 0, 0, 'Ln', pData); // X=2.4, Y=3.2 (mm), nFontH=12, nFontW=-1, nRotation=0, nStyle=0(Regular), bUnderline=0, bWhitOnBlack=0
        pData := '156 ';
        bResult := PrintTrueTypeFontA(24.9, 16.7, 14, -1, 0, 0, 0, 0, 'Ln', pData); // X=24.9, Y=16.7 (mm), nFontH=12, nFontW=-1, nRotation=0, nStyle=0(Regular), bUnderline=0, bWhitOnBlack=0
        pData := '123456789012345';
        StrLen := Length(pData);
        bResult := PrintBarcode(5.0, 25.7, 8.7, 0, 1, 2, 4, 1, StrLen, pData); //X=5.0, Y=25.7(mm), fBarHeight=8.7, nRotation=0, nBarType=1(Code39), nNarrowBar=2, nWideBar=4, bHuman=Enabl

        //===== Send all data to printer to print out label with quantity and copy
        bResult := PrintLabel(1, 1, 0);

        //===== End
        bResult := messagebox(0, '--- Test2 End ---', 'Solution Delphi', MB_OK);
        FreeMem(acPortBuffer);

end;

procedure TForm1.ButPrintTTF_AlignmentClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4, 3, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult := PrintTTF_AlignmentA(2.0, 1.5, 1.5, 2, 12, -1, 0, 3, 0, 0, 'Times New Roman', 'AaBbCcDd'); // nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
	bResult := PrintTTF_AlignmentA(2.0, 1.5, 1.5, 2, 12, -1, 1, 3, 0, 0, 'Times New Roman', 'AaBbCcDd'); // nFontH=12, nFontW=-1, nRotation=1, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
	bResult := PrintTTF_AlignmentA(2.0, 1.5, 1.5, 2, 12, -1, 2, 3, 0, 0, 'Times New Roman', 'AaBbCcDd'); // nFontH=12, nFontW=-1, nRotation=2, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
	bResult := PrintTTF_AlignmentA(2.0, 1.5, 1.5, 2, 12, -1, 3, 3, 0, 0, 'Times New Roman', 'AaBbCcDd'); // nFontH=12, nFontW=-1, nRotation=3, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
        bResult := PrintBox(0.5, 0.0, 2, 3.5, 3.0);
	bResult := PrintBox(1.3, 0.8, 2, 2.7, 2.2);

        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

procedure TForm1.ButPrintParagraphClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4, 3, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult := PrintParagraphA(2.0, 1.5, 1.5, 2, 12, -1, 0, 3, 0, 0, 'Times New Roman', 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz'); // nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
	bResult := PrintParagraphA(2.0, 1.5, 1.5, 2, 12, -1, 1, 3, 0, 0, 'Times New Roman', 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz'); // nFontH=12, nFontW=-1, nRotation=1, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
	bResult := PrintParagraphA(2.0, 1.5, 1.5, 2, 12, -1, 2, 3, 0, 0, 'Times New Roman', 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz'); // nFontH=12, nFontW=-1, nRotation=2, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
	bResult := PrintParagraphA(2.0, 1.5, 1.5, 2, 12, -1, 3, 3, 0, 0, 'Times New Roman', 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz'); // nFontH=12, nFontW=-1, nRotation=3, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
        bResult := PrintBox(0.55, 0.0, 2, 3.5, 3.0);

        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);

end;

procedure TForm1.ButPrintQRCodeClick(Sender: TObject);
var
    bResult: Integer;
    nPortCount: Integer;
    acPortBuffer: Pchar;
    nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen:Integer;
    pData: Pchar;
begin
        //Open USB port
        acPortBuffer := PChar(AllocMem(24));
        nPortCount := PortEnumCount(0); { Get USB count}
        bResult := PortEnumGet(0, 0, acPortBuffer);  {Get name of number 0 of USB port}
        bResult := PortOpen(acPortBuffer);
        If bResult = 0 Then
        begin
                messagebox(0, 'Can not open port!', 'Solution Delphi', MB_ICONERROR );
                FreeMem(acPortBuffer);
                Exit;
        end;
        bResult := SetMeasurement(1, 0); // inchs
	bResult := SetMedia_LabelWithGaps(4, 3, 0.16, 0); // W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
	bResult := SetPrinter(3, 8, 1); // nSpeed=3, nDarkness=8, bDirectThermal=1;

        nErrorCorrection := 0;
	nModel := 2;
	nMaskNumber := 0;
	nPixel := 4;
	nDataLen := 5;
	pData := '12345';

        bResult := PrintQRcode(2.0, 1.5, 0, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData);
        bResult := PrintQRcode(2.0, 1.5, 1, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData);
	bResult := PrintQRcode(2.0, 1.5, 2, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData);
	bResult := PrintQRcode(2.0, 1.5, 3, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData);
        bResult := PrintBox(1.49, 0.99, 2, 2.51, 2.01);

        bResult := PrintLabel(1, 1, 0);
        PortClose();
        messagebox(0, 'Finish!', 'Solution Delphi', MB_OK );
        FreeMem(acPortBuffer);
end;

end.

