Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'' Solution_VB.frm - VB Sample for SBARCO API DLL
	''
    '' Copyright (C) Sbarco Co. Ltd. 2010 - 2012  All rights reserved.
	''
	'' History - 2010/08/09 Ver:1.0 - First Release
	''           2010/11/11 Ver:1.1 - Add BarDrawer Functions
	''           2010/11/23 Ver:1.2 - Remove the rectangle of PrintImage function. The rectangle is for debuging.
	''           2011/05/26 Ver:1.4 - Fixed bug for Tear-Off Mode of SetAfterPrint Function.
	''           2011/06/09 Ver:1.5 - Function of PortOpen added an option of name pipe for sharing printer.
	''           2011/07/04 Ver:1.6 - Add function for SetReferencePoint, GetReferencePoint.
	''           2011/07/25 Ver:1.7 - Modify TPH width from 200 to 203 dpi.
	''                              - Fixed USB enum bug for one of longer USB register name.
    ''                              - Add function for Y offset of TPH.
    ''           2011/08/31 Ver:1.8 - Add Form Functions for FormSaveByFileA, FormSaveByFileW, FormCheck, FormExecute,
    ''                              - FormParameterData and FormPrint.
    ''                              - Add a FormTest sample in VC and VB.
    ''           2011/09/08 Ver:1.9 - Add Ethernet communication for PortEnumCount(), PortEnumGet() and PortOpen() Functions.
    ''           2011/10/03 Ver:1.10 - Add Delphi Sample Codes.
    ''                               - Fixed GetPrintDistance() bug in Dot Mode.
    ''                               - Change the DllAbout() return value from integer to double.
    ''           2011/12/08 Ver:1.11 - OpenPort() removed the query action.
    ''                               - PrintLabel() add a command for saving data to RAM.
    ''                               - When the print fails, the program automatically clears the memory of the print content.
    ''                               - If the program execution path exists file "DLLTOFILE.txt", the program will automatically print the contents to "DLLTOFILE.txt".
    ''                               - Add ImageSave(), ImagePrint(), ImageDelete() functions for not storing image for many times.
    ''           2012/02/13 Ver:1.12 - Add PrintTTF_AlignmentA, PrintTTF_AlignmentW for True Type Font Text with horizontal alignment.
    ''                                 Add PrintParagraphA, PrintParagraphW for True Type Font paragraph with horizontal alignement.
    ''                                 Add PrintQRcode for QR code.
    ''

    'Port Function
	Private Declare Function PortOpen Lib "SBSDK_API.DLL" (ByVal pPortName As String) As Integer
	Private Declare Sub PortClose Lib "SBSDK_API.DLL" ()
	Private Declare Function PortEnumCount Lib "SBSDK_API.DLL" (ByVal nPortType As Integer) As Integer
	Private Declare Function PortEnumGet Lib "SBSDK_API.DLL" (ByVal nPortType As Integer, ByVal nItem As Integer, ByVal pBuffer As String) As Integer
	Private Declare Function PortSetupSerial Lib "SBSDK_API.DLL" (ByVal nBaudRate As Integer, ByVal nDataBits As Integer, ByVal nParity As Integer, ByVal nStopBits As Integer, ByVal nFlowControl As Integer) As Integer
	'Setting Function
	Private Declare Function SetAfterPrint Lib "SBSDK_API.DLL" (ByVal nType As Integer, ByVal nCutPiece As Integer) As Integer
	Private Declare Function SetFontCharacterSet Lib "SBSDK_API.DLL" (ByVal nNumberBit As Integer, ByVal nCharacterSet As Integer) As Integer
	Private Declare Function SetMeasurement Lib "SBSDK_API.DLL" (ByVal nMeasurement As Integer, ByVal nResolution As Integer) As Integer
    Private Declare Function SetMedia_Continuous Lib "SBSDK_API.DLL" (ByVal fLabelWidth As Single, ByVal fLabelLen As Single, ByVal fStopOffset As Single) As Integer
    Private Declare Function SetMedia_LabelWithGaps Lib "SBSDK_API.DLL" (ByVal nLabelWidth As Single, ByVal nLabelLen As Single, ByVal nGapLen As Single, ByVal nGapOffset As Single) As Integer
    Private Declare Function SetMedia_LabelWithMarks Lib "SBSDK_API.DLL" (ByVal fLabelWidth As Integer, ByVal fLabelLen As Integer, ByVal fBlackLineLen As Integer, ByVal fThicknessOffset As Integer) As Integer
	Private Declare Function SetPrinter Lib "SBSDK_API.DLL" (ByVal nSpeed As Integer, ByVal nDarkness As Integer, ByVal bDirectThermal As Integer) As Integer
	Private Declare Function SetReferencePoint Lib "SBSDK_API.DLL" (ByVal nHoriDot As Integer, ByVal nVertDot As Integer) As Integer
	Private Declare Function SetTPH_YOffset Lib "SBSDK_API.DLL" (ByVal nOffsetDot As Integer) As Integer
	'Print Function
    Private Declare Function PrintText Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal nRotation As Integer, ByVal nFontID As Integer, ByVal nFontHor As Integer, ByVal nFontVer As Integer, ByVal bReverse As Integer, ByVal nDataLen As Integer, ByVal pData As String) As Integer
    Private Declare Function PrintBarcode Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal fBarHeight As Single, ByVal nRotation As Integer, ByVal nBarType As Integer, ByVal nNarrowBar As Integer, ByVal nWideBar As Integer, ByVal bHuman As Integer, ByVal nDataLen As Integer, ByVal pData As String) As Integer
    Private Declare Function PrintPDF417 Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal nRotation As Integer, ByVal nCorrectionLevel As Integer, ByVal bCompression As Integer, ByVal nModuleWidth As Integer, ByVal nBarHeight As Integer, ByVal nMaxColumns As Integer, ByVal nMaxRows As Integer, ByVal nTruncated As Integer, ByVal nDataLen As Integer, ByVal pData As String) As Integer
    Private Declare Function PrintQRcode Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal nRotation As Integer, ByVal nErrorCorrection As Integer, ByVal nModel As Integer, ByVal nMaskNumber As Integer, ByVal nPixel As Integer, ByVal nDataLen As Integer, ByVal pData As String) As Integer
    Private Declare Function PrintDataMatrix Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal nRotation As Integer, ByVal nColumns As Integer, ByVal nRows As Integer, ByVal nSquare As Integer, ByVal bInverseImage As Integer, ByVal nDataLen As Integer, ByVal pData As String) As Integer
    Private Declare Function PrintMaxiCode Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal nRotation As Integer, ByVal nMode As Integer, ByVal nDataLen As Integer, ByVal pData As String) As Integer
    Private Declare Function PrintLine Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal fHoriLength As Single, ByVal fVertLength As Single, ByVal nDrawMethod As Integer) As Integer
    Private Declare Function PrintBox Lib "SBSDK_API.DLL" (ByVal fX1 As Single, ByVal fY1 As Single, ByVal nThickness As Integer, ByVal fX2 As Single, ByVal fY2 As Single) As Integer
    Private Declare Function PrintImage Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal fWidth As Single, ByVal fHeight As Single, ByVal nRotation As Integer, ByVal bErrorDiffusion As Integer, ByVal pFileName As String) As Integer
    Private Declare Function PrintParagraphA Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal fRangeWidth As Single, ByVal nAlignment As Integer, ByVal nFontH As Integer, ByVal nFontW As Integer, ByVal nRotation As Integer, ByVal nStyle As Integer, ByVal bUnderline As Integer, ByVal bWhitOnBlack As Integer, ByVal pFaceName As String, ByVal pText As String) As Integer
    Private Declare Function PrintTrueTypeFontA Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal nFontH As Integer, ByVal nFontW As Integer, ByVal nRotation As Integer, ByVal nStyle As Integer, ByVal bUnderline As Integer, ByVal bWhitOnBlack As Integer, ByVal pFaceName As String, ByVal pText As String) As Integer
    Private Declare Function PrintTTF_AlignmentA Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal fRangeWidth As Single, ByVal nAlignment As Integer, ByVal nFontH As Integer, ByVal nFontW As Integer, ByVal nRotation As Integer, ByVal nStyle As Integer, ByVal bUnderline As Integer, ByVal bWhitOnBlack As Integer, ByVal pFaceName As String, ByVal pText As String) As Integer
    Private Declare Function PrintLabel Lib "SBSDK_API.DLL" (ByVal nSet As Integer, ByVal nCopy As Integer, ByVal bReverse As Integer) As Integer
    Private Declare Function Image_Save Lib "SBSDK_API.DLL" (ByVal fWidth As Single, ByVal fHeight As Single, ByVal nRotation As Integer, ByVal bErrorDiffusion As Integer, ByVal pFileName As String, ByVal pIDString As String) As Integer
    Private Declare Function Image_Print Lib "SBSDK_API.DLL" (ByVal fX As Single, ByVal fY As Single, ByVal pIDString As String) As Integer
    Private Declare Function Image_Delete Lib "SBSDK_API.DLL" (ByVal pIDString As String) As Integer
    'Form Function
    Private Declare Function FormSaveByFileA Lib "SBSDK_API.DLL" (ByVal pFileName As String) As Integer
    Private Declare Function FormSaveByFileW Lib "SBSDK_API.DLL" (ByVal ptcFileName As String) As Integer
    Private Declare Function FormCheck Lib "SBSDK_API.DLL" (ByVal pFormName As String) As Integer
    Private Declare Function FormExecute Lib "SBSDK_API.DLL" (ByVal pFormName As String) As Integer
    Private Declare Function FormParameterData Lib "SBSDK_API.DLL" (ByVal pData As String) As Integer
    Private Declare Function FormPrint Lib "SBSDK_API.DLL" (ByVal nSet As Integer, ByVal nCopy As Integer) As Integer
    'Demand Functions
	Private Declare Sub DemandCalibrationTest Lib "SBSDK_API.DLL" ()
	Private Declare Sub DemandFactoryDefaults Lib "SBSDK_API.DLL" ()
	Private Declare Sub DemandLabelFeed Lib "SBSDK_API.DLL" ()
	Private Declare Sub DemandPrintConfiguration Lib "SBSDK_API.DLL" ()
	Private Declare Sub DemandResetPrinter Lib "SBSDK_API.DLL" ()
	' Getting Functions
	Private Declare Function GetEmulationType Lib "SBSDK_API.DLL" () As Integer
	Private Declare Function GetFirmwareVersion Lib "SBSDK_API.DLL" (ByVal pBuffer As String) As Integer
	Private Declare Function GetPrintDistance Lib "SBSDK_API.DLL" (ByVal nMeasurement As Integer) As Integer
	Private Declare Function GetPrinterStatus Lib "SBSDK_API.DLL" () As Integer
	Private Declare Function GetReferencePoint Lib "SBSDK_API.DLL" (ByVal nAxisType As Integer) As Integer
	Private Declare Function GetResolution Lib "SBSDK_API.DLL" () As Integer
	Private Declare Function GetSerialNumber Lib "SBSDK_API.DLL" (ByVal pBuffer As String) As Integer
	Private Declare Function GetTPH_YOffset Lib "SBSDK_API.DLL" () As Integer
	'Other Functions
    Private Declare Function DllAbout Lib "SBSDK_API.DLL" (ByVal bDisplay As Integer) As Double
	Private Declare Function SendCmd Lib "SBSDK_API.DLL" (ByVal nDataLen As Integer, ByVal lpData As String) As Integer
	Private Declare Function SendFileA Lib "SBSDK_API.DLL" (ByVal pFileName As String) As Integer
	'BarDrawer Functions
	Private Declare Function BarDrawer_DatabaseSet Lib "SBSDK_API.DLL" (ByVal nType As Integer, ByVal nSaveInfos As Integer, ByVal pstrFilePath As String, ByVal pstrUserName As String, ByVal pstrPassword As String, ByVal pstrTable As String) As Integer
	Private Declare Function BarDrawer_Launch Lib "SBSDK_API.DLL" (ByVal pFileName As String) As Integer
	Private Declare Function BarDrawer_LaunchNew Lib "SBSDK_API.DLL" (ByVal pFileName As String) As Integer
	
    Private Sub _But_BarDrawerLaunch_0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_BarDrawerLaunch_0.Click
        ' Launch BarDrawer with database setting or new a label file
        Dim bResult As Integer
        Dim nType As Integer
        Dim nSaveInfos As Integer
        Dim pstrFilePath As String
        Dim pstrUserName As String
        Dim pstrPassword As String
        Dim pstrTable As String
        nType = 1
        nSaveInfos = 1
        pstrFilePath = "Excel database.xls"
        pstrUserName = "Admin"
        pstrPassword = ""
        pstrTable = "Sheet1$"

        bResult = BarDrawer_DatabaseSet(nType, nSaveInfos, pstrFilePath, pstrUserName, pstrPassword, pstrTable)
        'bResult = BarDrawer_DatabaseSet(1, 1, "Excel database.xls", "Admin", "", "Sheet1$")
        bResult = BarDrawer_Launch("DLLTest.bdw")
        'bResult = BarDrawer_LaunchNew("Sample1.bdw")
        bResult = MsgBox("Launch BarDrawer Completely", 0, "Solution VB")

    End Sub
	
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    '' Printing Functions
   
    Private Sub _But_Text_0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_Text_0.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        bResult = SetMeasurement(1, 0) ' inchs
        bResult = PrintText(1.1, 1.1, 0, 1, 1, 1, 0, 8, "AaBbCcDd") ' X=2.1, Y=1.1 (inches), No rotation, Font1, Hor Expand=1, Ver Expand=1, normal image
        bResult = PrintLabel(1, 1, 0)
        Call PortClose()
    End Sub
    Private Sub _But_TrueTypeFont_1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_TrueTypeFont_1.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub


        bResult = SetMeasurement(1, 0) ' inchs
        bResult = PrintTrueTypeFontA(1, 1, 12, -1, 0, 3, 0, 1, "Times New Roman", "AaBbCcDd") ' nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=1

        Dim TStr As String
        TStr = Chr(&H53S) & Chr(&H42S) & Chr(&H41S) & Chr(&H52S) & Chr(&H43S) & Chr(&H4FS) & ChrW(&H5370S) & ChrW(&H8868S) & ChrW(&H6A5FS) & ChrW(&H53S) & ChrW(&H44S) & ChrW(&H4BS)
        bResult = PrintTrueTypeFontA(1, 2, 12, -1, 0, 3, 1, 0, "Times New Roman", TStr) ' nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=1, bWhitOnBlack=0

        bResult = PrintLabel(1, 1, 0)
        Call PortClose()
    End Sub
    Private Sub _But_TTF_ALIGNMENT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_TTF_ALIGNMENT.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        bResult = SetMeasurement(1, 0) 'inchs
        bResult = SetMedia_LabelWithGaps(4, 3, 0.16F, 0) 'W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
        bResult = SetPrinter(3, 8, 1) 'nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult = PrintTTF_AlignmentA(2.0, 1.5, 1.5, 2, 12, -1, 0, 3, 0, 0, "Times New Roman", "AaBbCcDd") ' nFontH=12, nFontW=-1, nRotation=0, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
        bResult = PrintTTF_AlignmentA(2.0, 1.5, 1.5, 2, 12, -1, 1, 3, 0, 0, "Times New Roman", "AaBbCcDd") ' nFontH=12, nFontW=-1, nRotation=1, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
        bResult = PrintTTF_AlignmentA(2.0, 1.5, 1.5, 2, 12, -1, 2, 3, 0, 0, "Times New Roman", "AaBbCcDd") ' nFontH=12, nFontW=-1, nRotation=2, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0
        bResult = PrintTTF_AlignmentA(2.0, 1.5, 1.5, 2, 12, -1, 3, 3, 0, 0, "Times New Roman", "AaBbCcDd") ' nFontH=12, nFontW=-1, nRotation=3, nStyle=3(Bold and Italic), bUnderline=0, bWhitOnBlack=0

        bResult = PrintLabel(1, 1, 0)
        Call PortClose()
    End Sub

    Private Sub _But_PRINT_PARAGRAPH_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_PRINT_PARAGRAPH.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub


        bResult = SetMeasurement(1, 0) ' inchs
        bResult = SetMedia_LabelWithGaps(4, 3, 0.16F, 0) ' W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
        bResult = SetPrinter(3, 8, 1) ' nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult = PrintParagraphA(2.0, 1.5, 1.5, 2, 12, -1, 0, 0, 0, 0, "Times New Roman", "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz") ' nFontH=12, nFontW=-1, nRotation=0, nStyle=0, bUnderline=0, bWhitOnBlack=0
        bResult = PrintParagraphA(2.0, 1.5, 1.5, 2, 12, -1, 1, 0, 0, 0, "Times New Roman", "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz") ' nFontH=12, nFontW=-1, nRotation=1, nStyle=0, bUnderline=0, bWhitOnBlack=0
        bResult = PrintParagraphA(2.0, 1.5, 1.5, 2, 12, -1, 2, 0, 0, 0, "Times New Roman", "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz") ' nFontH=12, nFontW=-1, nRotation=2, nStyle=0, bUnderline=0, bWhitOnBlack=0
        bResult = PrintParagraphA(2.0, 1.5, 1.5, 2, 12, -1, 3, 0, 0, 0, "Times New Roman", "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz") ' nFontH=12, nFontW=-1, nRotation=3, nStyle=0, bUnderline=0, bWhitOnBlack=0

        bResult = PrintLabel(1, 1, 0)
        Call PortClose()
    End Sub
	
	Private Sub But_Barcode_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_Barcode.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		'bResult = PortOpen("\\TESTPC\SbarcoT4-usb02")
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		bResult = SetMeasurement(1, 0) ' inchs
		bResult = PrintBarcode(1, 1, 0.3, 0, 1, 1, 2, 1, 5, "12345") ' fBarHeight=0.3, nRotation=0, nBarType=Code39, nNarrowBar=1, nWideBar=2, bHuman=Enabl
		bResult = PrintLabel(1, 1, 0)
		Call PortClose()
	End Sub
	
	Private Sub But_PDF417_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_PDF417.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		
        Dim nMaxRows, nBarHeight, bCompression, nCorrectionLevel, nModuleWidth, nMaxColumns, nTruncated As Integer
        Dim nDataLen As Integer
		
		nCorrectionLevel = 1
		bCompression = 0
		nModuleWidth = 1
		nBarHeight = 4
		nMaxColumns = 1
		nMaxRows = 10
		nTruncated = 1
		nDataLen = 5
		Dim pData As String
		pData = "12345"
		
		bResult = SetMeasurement(1, 0) ' inchs
		
        bResult = PrintPDF417(0.2, 0.2, 0, nCorrectionLevel, bCompression, nModuleWidth, nBarHeight, nMaxColumns, nMaxRows, nTruncated, nDataLen, pData) ' nRotation=0,
		
		bResult = PrintLabel(1, 1, 0)
		Call PortClose()
    End Sub
    Private Sub _But_PRINT_QRCODE_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_PRINT_QRCODE.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        Dim nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen As Integer
        Dim pData As String

        nErrorCorrection = 0
        nModel = 2
        nMaskNumber = 0
        nPixel = 4
        nDataLen = 5
        pData = "12345"

        bResult = SetMeasurement(1, 0) ' inchs
        bResult = SetMedia_LabelWithGaps(4.0, 3.0, 0.16, 0) ' W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
        bResult = SetPrinter(3, 8, 1) ' nSpeed=3, nDarkness=8, bDirectThermal=1;

        bResult = PrintQRcode(2.0, 1.5, 0, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData)
        bResult = PrintQRcode(2.0, 1.5, 1, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData)
        bResult = PrintQRcode(2.0, 1.5, 2, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData)
        bResult = PrintQRcode(2.0, 1.5, 3, nErrorCorrection, nModel, nMaskNumber, nPixel, nDataLen, pData)

        bResult = PrintLabel(1, 1, 0)
        Call PortClose()
    End Sub
	
	Private Sub But_DataMatrix_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_DataMatrix.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		
        Dim nSquare, nColumns, nRotation, nRows, bInverseImage As Integer
		Dim nDataLen As Integer
		
        nRotation = 0
		nColumns = 10
		nRows = 10
		nSquare = 4
		bInverseImage = 0
		nDataLen = 5
		Dim pData As String
		pData = "12345"
		
		bResult = SetMeasurement(1, 0) ' inchs
		
		bResult = PrintDataMatrix(0.8, 0.8, nRotation, nColumns, nRows, nSquare, bInverseImage, nDataLen, pData)
		
		bResult = PrintLabel(1, 1, 0)
		Call PortClose()
	End Sub
	
	Private Sub But_MaxiCode_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_MaxiCode.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		
        Dim nRotation, nMode As Integer
		Dim nDataLen As Integer
		
        nRotation = 0
		nMode = 0
        Dim pData As String
		pData = "300,840,93065,1692,This is MaxiCode,but not MaxiCode formatted data"
		
		bResult = SetMeasurement(1, 0) ' inchs
        nDataLen = Len(pData)
		bResult = PrintMaxiCode(0.8, 0.8, nRotation, nMode, nDataLen, pData)
		
		bResult = PrintLabel(1, 1, 0)
		Call PortClose()
	End Sub
	
	Private Sub But_Image_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_Image.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		bResult = SetMeasurement(1, 0) ' inchs
		bResult = PrintImage(0.5, 0.2, -1, -1, 0, 1, "TestImage.jpg") ' nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=1
        bResult = PrintImage(3, 0.2, 1, 1, 0, 0, "TestImage.jpg") ' nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=0
		bResult = PrintLabel(1, 1, 0)
        Call PortClose()
    End Sub

    Private Sub ButtonSavePrintImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSavePrintImage.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        bResult = SetMeasurement(1, 0) ' inchs
        bResult = SetMedia_LabelWithGaps(4, 3, 0.16, 0) ' W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
        bResult = Image_Save(1.0F, 1.0F, 0, 0, "TestImage.jpg", "IMAGE_01") ' nWidth=-1(Original Size), nHeight=-1(Original Size), bErrorDiffusion=0


        ' print image with the ID specified
        bResult = Image_Print(3.0F, 0.2F, "IMAGE_01")
        bResult = Image_Print(1.0F, 0.2F, "IMAGE_01")
        bResult = PrintLabel(1, 1, 0)

        Call PortClose()


        '===== Second time to print image wit ID-sting
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        ' print image with the ID specified
        bResult = Image_Print(0.0F, 0.2F, "IMAGE_01")
        bResult = Image_Print(2.0F, 0.2F, "IMAGE_01")
        bResult = PrintLabel(1, 1, 0)

        ' delete image with the ID specified
        bResult = Image_Delete("IMAGE_01")
        Call PortClose()
    End Sub
	
	Private Sub But_Line_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_Line.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		bResult = SetMeasurement(0, 0) ' dots
        bResult = PrintLine(50, 100, 200, 5, 0) ' Black Line
        bResult = PrintLine(100, 50, 5, 200, 0) ' Black Line
        bResult = PrintLine(150, 50, 5, 200, 1) ' White Line
        bResult = PrintLine(200, 50, 5, 200, 2) ' Exclusive OR Line
		bResult = PrintLabel(1, 1, 0)
		Call PortClose()
	End Sub
	
	Private Sub But_Box_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_Box.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		bResult = SetMeasurement(1, 0) ' inchs
		bResult = PrintBox(0.5, 0.5, 12, 1, 1) ' (0.5, 0.5) to (1, 1) inch with 12 dots thickness
		bResult = PrintLabel(1, 1, 0)
		Call PortClose()
	End Sub
	
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'' Port Functions
	Private Sub But_EnumerateUSBPort_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_EnumerateUSBPort.Click
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		
		nPortCount = PortEnumCount(0) ' Get USB count
		
		If nPortCount > 0 Then
			bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
			bResult = PortOpen(acPortBuffer)
			bResult = SetMeasurement(1, 0) ' inchs
			bResult = PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 14, "Print from USB")
			bResult = PrintLabel(1, 1, 0)
			Call PortClose()
		End If
    End Sub

    Private Sub SendToEthernet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SendToEthernet.Click
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)

        nPortCount = PortEnumCount(3) ' Get Ethernet

        If nPortCount > 0 Then
            bResult = PortEnumGet(3, 0, acPortBuffer) ' Get IP Address of number 0 of Ethernet
            bResult = PortOpen(acPortBuffer)
            'bResult = PortOpen("192.168.11.2")
            bResult = SetMeasurement(1, 0) ' inchs
            bResult = PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 14, "Print from Ethernet")
            bResult = PrintLabel(1, 1, 0)
            Call PortClose()
        End If
    End Sub

    Private Sub SendToLpt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SendToLpt.Click
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)

        nPortCount = PortEnumCount(2) ' Get LPT count

        If nPortCount > 0 Then
            bResult = PortEnumGet(2, 0, acPortBuffer) ' Get name of number 0 of LPT port
            bResult = PortOpen(acPortBuffer)
            bResult = SetMeasurement(1, 0) ' inchs
            bResult = PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 14, "Print from LPT")
            bResult = PrintLabel(1, 1, 0)
            Call PortClose()
        End If
    End Sub
	
	Private Sub But_EnumerateRS232Port_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_EnumerateRS232Port.Click
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		
		nPortCount = PortEnumCount(1) ' Get RS232 count
		
		If nPortCount > 0 Then
            bResult = PortEnumGet(1, 0, acPortBuffer) ' Get name of number 1 of RS232 port
            bResult = PortSetupSerial(115200, 8, 0, 1, 1) ' 115200 bps, 8 data-bits, no parity, 1 stop bit, hardware flowing control.
            bResult = PortOpen(acPortBuffer)
			bResult = SetMeasurement(1, 0) ' inchs
			bResult = PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 17, "Print from RS232")
			bResult = PrintLabel(1, 1, 0)
			Call PortClose()
		End If
	End Sub
	
	Private Sub But_SetRS232Port_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_SetRS232Port.Click
		Dim bResult As Integer
        bResult = PortSetupSerial(115200, 8, 0, 1, 1) ' 115200 bps, 8 data-bits, no parity, 1 stop bit, hardware flowing control.
        bResult = PortOpen("COM1")
		bResult = SetMeasurement(1, 0) ' inchs
		bResult = PrintText(1.1, 0.2, 0, 1, 1, 1, 0, 17, "Print from RS232")
		bResult = PrintLabel(1, 1, 0)
		Call PortClose()
	End Sub
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    '' Demand Functions
    Private Sub _But_Demand_CalTest_0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_Demand_CalTest_0.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        Call DemandCalibrationTest() 'demand the printer to run a calibration test.
        Call PortClose()
        bResult = MsgBox("Finish DemandCalibrationTest", 0, "Solution VB")
    End Sub
    Private Sub _But_Demand_FacDef_1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_Demand_FacDef_1.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        Call DemandFactoryDefaults() 'demand the printer to make itself to be factory defaults.
        Call PortClose()
        bResult = MsgBox("Finish DemandFactoryDefaults", 0, "Solution VB")
    End Sub
    Private Sub _But_Demand_LabFeed_2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_Demand_LabFeed_2.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        Call DemandLabelFeed() 'demand the printer to feed out a blank label.
        Call PortClose()
        bResult = MsgBox("Finish DemandLabelFeed", 0, "Solution VB")
    End Sub
    Private Sub _But_Demand_PrnCon_3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_Demand_PrnCon_3.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub

        Call DemandPrintConfiguration() 'demand the printer to print out a label with printer configuration.
        Call PortClose()
        bResult = MsgBox("Finish DemandPrintConfiguration", 0, "Solution VB")
    End Sub
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'' Functions
	Private Sub But_Setting_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_Setting.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        'bResult = PortOpen(acPortBuffer)
        'If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		
		bResult = SetMeasurement(1, 0) ' nMeasurement=0(Dots), 1(Inches), 2(Centimeters), 3(Millimeters); nResolution=0(Currecnt Set)
		bResult = SetMedia_Continuous(4, 3, 0.1) ' W=4 inch, H=3Inch, StopOffset=0.1 inch;
		
		bResult = SetMeasurement(0, 0) ' nMeasurement=0(Dots), 1(Inches), 2(Centimeters), 3(Millimeters); nResolution=0(Currecnt Set)
        bResult = SetMedia_LabelWithGaps(800, 600, 32, 0) ' W=4 inch, H=3Inch, GapLen=32 dots, GapOffset=0;
		
		bResult = SetMeasurement(2, 0) ' nMeasurement=0(Dots), 1(Inches), 2(Centimeters), 3(Millimeters); nResolution=0(Currecnt Set)
		bResult = SetMedia_LabelWithMarks(10, 6, 0.4, 0)
		
		bResult = SetPrinter(3, 10, 1) ' nSpeed=3, nDarkness=10, bDirectThermal=1;
		bResult = SetReferencePoint(0, 0) ' Set X and Y axis to 0 dot.
		bResult = SetTPH_YOffset(0) ' Set Y offset of TPH to 0 dot.
		
		bResult = SetAfterPrint(1, 0) ' Enable Tear-Off mode after printing.
		bResult = SetFontCharacterSet(7, 0) ' 7 Bit Data with USA character Set
		bResult = PrintLabel(0, 0, 0) ' Only send data to printer without printing
		
		Call PortClose()
	End Sub
	
	Private Sub But_Getting_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles But_Getting.Click
		' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		'bResult = PortOpen("COM1") ' not for LPT port
        'bResult = PortSetupSerial(115200, 8, 0, 1, 1) ' 115200 bps, 8 data-bits, no parity, 1 stop bit, hardware flowing control.
		
		Dim acBuffer As String
		acBuffer = New String(vbNullChar, 80)
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'''' Get Printer Emulation
		If GetEmulationType() = 100 Then
			bResult = MsgBox("PEPL Emulation", 0, "Solution VB")
		Else
			bResult = MsgBox("Can't get emulation from printer", 0, "Solution VB")
		End If
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'''' Get Printer Firmware Version
		bResult = GetFirmwareVersion(acBuffer)
		bResult = MsgBox(acBuffer, 0, "Solution VB")
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'''' Get Printed Distance
		Dim nDistanceDots As Integer
		nDistanceDots = GetPrintDistance(0) ' Dots
		Dim nDistanceInchs As Integer
		nDistanceInchs = GetPrintDistance(1) ' inchs
		Dim nDistanceCm As Integer
		nDistanceCm = GetPrintDistance(2) ' CentiMeters
		Dim nDistanceMm As Integer
		nDistanceMm = GetPrintDistance(3) ' Millimeters
		
		Dim strMessage As String
		strMessage = CStr(nDistanceDots) & " dots, " & CStr(nDistanceInchs) & " inchs, " & CStr(nDistanceCm) & " cm, " & CStr(nDistanceMm) & " mm, " & CStr(nDistanceCm / 100 / 1000) & " km"
		bResult = MsgBox(strMessage, 0, "Solution VB")
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'''' Get Current Status
		Dim nErrorCode As Integer
		nErrorCode = GetPrinterStatus()
		If nErrorCode = 0 Then
			bResult = MsgBox("Printr Status: Ready", 0, "Solution VB")
		Else
			strMessage = "Printr Status: Error Code " & CStr(nErrorCode)
			bResult = MsgBox(strMessage, 0, "Solution VB")
		End If
		
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'''' Get Printer Resolution
		Dim nResolution As Integer
		nResolution = GetResolution()
		strMessage = CStr(nResolution) & " dpi"
		bResult = MsgBox(strMessage, 0, "Solution VB")
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'''' Get Printer Serial Number
        'Dim nBufLen As Integer
		If GetSerialNumber(acBuffer) > 0 Then
			strMessage = "Serial Number: " & acBuffer
			bResult = MsgBox(strMessage, 0, "Solution VB")
		Else
			bResult = MsgBox("Can't get serial number", 0, "Solution VB")
		End If
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'''' Get Reference Point
		Dim nAxisX As Integer
		Dim nAxisY As Integer
		nAxisX = GetReferencePoint(0) ' Get X axis in dot.
		nAxisY = GetReferencePoint(1) ' Get Y axis in dot.
		strMessage = "X axis = " & CStr(nAxisX) & ",  Y axis = " & CStr(nAxisY) & "  (dots)"
		bResult = MsgBox(strMessage, 0, "Solution VB")
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'''' Get TPH Y Offset
		Dim nTphY As Integer
		nTphY = GetTPH_YOffset() ' Get TPH Y offset in dot.
		strMessage = "TPH Y Offset = " & CStr(nTphY) & "  (dots)"
		bResult = MsgBox(strMessage, 0, "Solution VB")
		
		Call PortClose()
	End Sub
    Private Sub _But_AboutDLL_1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_AboutDLL_1.Click
        Dim dbVersion As Double
        dbVersion = DllAbout(1) ' 1=display dialog, 0=only return version

        Dim bResult As Integer
        Dim strVersion As String
        strVersion = "DLL Version: " & CStr(dbVersion)
        bResult = MsgBox(strVersion, 0, "Solution VB")
    End Sub
    Private Sub _But_AboutSolutionVB_2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_AboutSolutionVB_2.Click
        Dim bResult As Integer
        bResult = MsgBox("Solution_VB Version: 1.8", 0, "Solution VB")
    End Sub
    Private Sub _But_SendCommands1_0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_SendCommands1_0.Click
        ' Open USB port
		Dim bResult As Integer
		Dim nPortCount As Integer
		Dim acPortBuffer As String
		acPortBuffer = New String(vbNullChar, 24)
		nPortCount = PortEnumCount(0) ' Get USB count
		bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
		bResult = PortOpen(acPortBuffer)
		If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub
		
		
        Dim nDataLen As Integer
		Dim nSendLen As Integer
		Dim acData As String
		acData = Chr(13) & Chr(10) & "ZT" & Chr(13) & Chr(10) & "B200,200,0,3,1,2,60,B," & Chr(34) & "12345" & Chr(34) & Chr(13) & Chr(10) & "P1" & Chr(13) & Chr(10)
		
        nDataLen = Len(acData)
        nSendLen = SendCmd(nDataLen, acData)
		If nDataLen = nSendLen Then
        Else
            bResult = MsgBox("The data length is not correct.", 0, "Solution VB")
        End If
		
		Call PortClose()
	End Sub
    Private Sub _But_SendCommands2_1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_SendCommands2_1.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub


        Dim nSendLen As Integer
        Dim strMessage As String

        nSendLen = SendCmd(-1, CStr(0))
        strMessage = "Data length = " & CStr(nSendLen)
        bResult = MsgBox(strMessage, 0, "Solution VB")

        Call PortClose()
    End Sub
    Private Sub _But_SendFile1_3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_SendFile1_3.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub


        Dim nDataLen As Integer
        nDataLen = SendFileA("testcmd.txt")

        Dim strMessage As String
        strMessage = "Data length = " & CStr(nDataLen)
        bResult = MsgBox(strMessage, 0, "Solution VB")

        Call PortClose()
    End Sub
    Private Sub _But_SendFile2_0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _But_SendFile2_0.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        'bResult = PortOpen("\\TESTPC\SbarcoT4-usb02")
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub


        Dim nDataLen As Integer
        nDataLen = SendFileA("open")

        Dim strMessage As String
        strMessage = "Data length = " & CStr(nDataLen)
        bResult = MsgBox(strMessage, 0, "Solution VB")

        Call PortClose()
    End Sub

    Private Sub Button_FormTestClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' Open USB port
        Dim bResult As Integer
        Dim nPortCount As Integer
        Dim acPortBuffer As String
        acPortBuffer = New String(vbNullChar, 24)
        nPortCount = PortEnumCount(0) ' Get USB count
        bResult = PortEnumGet(0, 0, acPortBuffer) ' Get name of number 0 of USB port
        bResult = PortOpen(acPortBuffer)
        'bResult = PortOpen("c:\\testfile.txt") ' for test, you can send all data to file.
        If bResult = 0 Then bResult = MsgBox("Can't open port!", 0, "Solution VB") : Exit Sub


        '===== Send form file to printer
        Dim nDataLen As Integer
        bResult = FormCheck("TRUNCATION")

        If bResult = 0 Then
            nDataLen = FormSaveByFileA("Sample_Truncation_Form.prn") ' please get the file before testing
            If nDataLen = 0 Then bResult = MsgBox("Can't open file!", 0, "Solution VB") : Call PortClose() : Exit Sub
        End If

        '===== Send Parameter Data to printer
        FormExecute("TRUNCATION") 'Send command to printer to execute form by form name "TRUNCATION".
        FormParameterData("FF12345678")
        FormParameterData("RR87654321")
        FormPrint(1, 1)
        Call PortClose()


        bResult = MsgBox("--- Test End ---", 0, "Solution VB")

    End Sub

    
    
    
    
End Class