// SDK_API.h
// Version 1.17

#ifdef  _APIEXPORT
#define SBAPI extern "C" __declspec(dllexport)
#else
#define SBAPI extern "C" __declspec(dllimport)
#endif

// Port Functions
SBAPI void _stdcall PortClose();
SBAPI int _stdcall PortEnumCount(int nPortType);
SBAPI BOOL _stdcall PortEnumGet(int nPortType, int nItem, char* pBuffer);
SBAPI BOOL _stdcall PortOpen(char* pPortName);
SBAPI BOOL _stdcall PortOpen_USB(int nID);
SBAPI BOOL _stdcall PortSetupSerial(int nBaudRate, int nDataBits, int nParity, int nStopBits, int nFlowControl);
// Setting Functions
SBAPI BOOL _stdcall SetAfterPrint(int nType, int nCutPiece);
SBAPI BOOL _stdcall SetFontCharacterSet(int nNumberBit, int nCharacterSet);
SBAPI BOOL _stdcall SetMeasurement(int nMeasurement, int nResolution);
SBAPI BOOL _stdcall SetMedia_Continuous(float fLabelWidth, float fLabelLen, float fStopOffset);
SBAPI BOOL _stdcall SetMedia_LabelWithGaps(float fLabelWidth, float fLabelLen, float fGapLen, float fGapOffset);
SBAPI BOOL _stdcall SetMedia_LabelWithMarks(float fLabelWidth, float fLabelLen, float fBlackLineLen, float fThicknessOffset);
SBAPI BOOL _stdcall SetPrinter(int nSpeed, int nDarkness, BOOL bDirectThermal);
SBAPI BOOL _stdcall SetReferencePoint(int nHoriDot, int nVertDot);
SBAPI BOOL _stdcall SetTPH_YOffset(int nOffsetDot);
// Print Functions
SBAPI BOOL _stdcall PrintText(float fX, float fY, int nRotation, int nFontID, int nFontHor, int nFontVer, BOOL bReverse, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintTextA(float fX, float fY, int nRotation, int nFontID, int nFontHor, int nFontVer, BOOL bReverse, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintTextW(float fX, float fY, int nRotation, int nFontID, int nFontHor, int nFontVer, BOOL bReverse, int nDataLen, TCHAR* ptcData);
SBAPI BOOL _stdcall PrintBarcode(float fX, float fY, float fBarHeight, int nRotation, int nBarType, int nNarrowBar, int nWideBar, BOOL bHuman, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintBarcodeA(float fX, float fY, float fBarHeight, int nRotation, int nBarType, int nNarrowBar, int nWideBar, BOOL bHuman, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintBarcodeW(float fX, float fY, float fBarHeight, int nRotation, int nBarType, int nNarrowBar, int nWideBar, BOOL bHuman, int nDataLen, TCHAR* ptcData);
SBAPI BOOL _stdcall PrintPDF417(float fX, float fY, int nRotation, int nCorrectionLevel, BOOL bCompression, int nModuleWidth,
								int nBarHeight, int nMaxColumns, int nMaxRows, int nTruncated, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintPDF417A(float fX, float fY, int nRotation, int nCorrectionLevel, BOOL bCompression, int nModuleWidth,
								int nBarHeight, int nMaxColumns, int nMaxRows, int nTruncated, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintPDF417W(float fX, float fY, int nRotation, int nCorrectionLevel, BOOL bCompression, int nModuleWidth,
								int nBarHeight, int nMaxColumns, int nMaxRows, int nTruncated, int nDataLen, TCHAR* ptcData);
SBAPI BOOL _stdcall PrintDataMatrix(float fX, float fY, int nRotation, int nColumns, int nRows, int nSquare, BOOL bInverseImage, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintDataMatrixA(float fX, float fY, int nRotation, int nColumns, int nRows, int nSquare, BOOL bInverseImage, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintDataMatrixW(float fX, float fY, int nRotation, int nColumns, int nRows, int nSquare, BOOL bInverseImage, int nDataLen, TCHAR* ptcData);
SBAPI BOOL _stdcall PrintMaxiCode(float fX, float fY, int nRotation, int nMode, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintMaxiCodeA(float fX, float fY, int nRotation, int nMode, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintMaxiCodeW(float fX, float fY, int nRotation, int nMode, int nDataLen, TCHAR* ptcData);
SBAPI BOOL _stdcall PrintQRcode(float fX, float fY, int nRotation, int nErrorCorrection, int nModel, int nMaskNumber, int nPixel, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintQRcodeA(float fX, float fY, int nRotation, int nErrorCorrection, int nModel, int nMaskNumber, int nPixel, int nDataLen, char* pData);
SBAPI BOOL _stdcall PrintQRcodeW(float fX, float fY, int nRotation, int nErrorCorrection, int nModel, int nMaskNumber, int nPixel, int nDataLen, TCHAR* ptcData);
SBAPI BOOL _stdcall PrintLine(float fX, float fY, float fHoriLength, float fVertLength, int nDrawMethod);
SBAPI BOOL _stdcall PrintBox(float fX1, float fY1, int nThickness, float fX2, float fY2);
SBAPI BOOL _stdcall PrintRoundBox(float fX1, float fY1, int nThickness, float fX2, float fY2, int nLineStyle, int nCornerWidth);
SBAPI BOOL _stdcall PrintEllipse(float fX1, float fY1, int nThickness, float fX2, float fY2, int nLineStyle);
SBAPI BOOL _stdcall PrintDiagonal(float fX1, float fY1, int nThickness, float fX2, float fY2, int nLineStyle);
SBAPI BOOL _stdcall PrintImage(float fX, float fY, float fWidth, float fHeight, int nRotation, BOOL bErrorDiffusion, char* pFileName);
SBAPI BOOL _stdcall PrintTTF_AlignmentW(float fX, float fY, float fRangeWidth, int nAlignment, int nFontH, int nFontW, int nRotation, int nStyle, BOOL bUnderline, BOOL bWhitOnBlack, TCHAR* ptcFaceName, TCHAR* ptcText);
SBAPI BOOL _stdcall PrintTTF_AlignmentA(float fX, float fY, float fRangeWidth, int nAlignment, int nFontH, int nFontW, int nRotation, int nStyle, BOOL bUnderline, BOOL bWhitOnBlack, char* pFaceName, char* pText);
SBAPI BOOL _stdcall PrintTrueTypeFontW(float fX, float fY, int nFontH, int nFontW, int nRotation, int nStyle, BOOL bUnderline, BOOL bWhitOnBlack, TCHAR* ptcFaceName, TCHAR* ptcText);
SBAPI BOOL _stdcall PrintTrueTypeFontA(float fX, float fY, int nFontH, int nFontW, int nRotation, int nStyle, BOOL bUnderline, BOOL bWhitOnBlack, char* pFaceName, char* pText);
SBAPI BOOL _stdcall PrintParagraphW(float fX, float fY, float fRangeWidth, int nAlignment, int nFontH, int nFontW, int nRotation, int nStyle, BOOL bUnderline, BOOL bWhitOnBlack, TCHAR* ptcFaceName, TCHAR* ptcText);
SBAPI BOOL _stdcall PrintParagraphA(float fX, float fY, float fRangeWidth, int nAlignment, int nFontH, int nFontW, int nRotation, int nStyle, BOOL bUnderline, BOOL bWhitOnBlack, char* pFaceName, char* pText);
SBAPI BOOL _stdcall PrintLabel(int nSet, int nCopy, BOOL bReverse);
SBAPI BOOL _stdcall Image_Save(float fWidth, float fHeight, int nRotation, BOOL bErrorDiffusion, char* pFileName, char* pIDString);
SBAPI BOOL _stdcall Image_Print(float fX, float fY ,char* pIDString);
SBAPI BOOL _stdcall Image_Delete(char* pIDString);
// Form Function
SBAPI int _stdcall FormSaveByFileA(char* pFileName);
SBAPI int _stdcall FormSaveByFileW(TCHAR* ptcFileName);
SBAPI BOOL _stdcall FormCheck(char* pFormName);
SBAPI BOOL _stdcall FormExecute(char* pFormName);
SBAPI BOOL _stdcall FormParameterData(char* pData);
SBAPI BOOL _stdcall FormPrint(int nSet, int nCopy);
// Demand Functions
SBAPI BOOL _stdcall DemandCalibrationTest();
SBAPI BOOL _stdcall DemandFactoryDefaults();
SBAPI BOOL _stdcall DemandResetPrinter();
SBAPI BOOL _stdcall DemandLabelFeed();
SBAPI BOOL _stdcall DemandPrintConfiguration();
// Getting Functions
SBAPI int _stdcall GetEmulationType();
SBAPI int _stdcall GetFirmwareVersion(char* pBuffer);
SBAPI int _stdcall GetPrintDistance(int nMeasurement);
SBAPI int _stdcall GetPrinterStatus();
SBAPI int _stdcall GetReferencePoint(int nAxisType);
SBAPI int _stdcall GetResolution();
SBAPI int _stdcall GetSerialNumber(char* pBuffer);
SBAPI int _stdcall GetTPH_YOffset();
// Other Functions
SBAPI double _stdcall DllAbout(BOOL bDisplay);
SBAPI int _stdcall SendCmd(int nDataLen, LPBYTE lpData);
SBAPI int _stdcall SendFileA(char* pFileName);
SBAPI int _stdcall SendFileW(TCHAR* ptcFileName);

// BarDrawer Functions
SBAPI BOOL _stdcall BarDrawer_DatabaseSet(int nType, BOOL nSaveInfos, char* pstrFilePath, char* pstrUserName, char* pstrPassword, char* pstrTable);
SBAPI BOOL _stdcall BarDrawer_Launch(char* pFileName);
SBAPI BOOL _stdcall BarDrawer_LaunchNew(char* pFileName);

SBAPI int _stdcall CmdParserBufA(char* pString);
SBAPI int _stdcall CmdParserBufW(TCHAR* ptcString);
SBAPI int _stdcall CmdParserFileA(char* pFileName);
SBAPI int _stdcall CmdParserFileW(TCHAR* ptcFileName);
// Line Print
SBAPI void _stdcall LinePrint_Row_Set(float fHeight);
SBAPI void _stdcall LinePrint_TTF_Set(int nFontH, int nFontW, int nRotation, int nStyle, BOOL bUnderline, BOOL bWhitOnBlack, TCHAR* ptcFaceName);
SBAPI void _stdcall LinePrint_TTF_Print(BOOL bAppend, float fX, float fRangeWidth, int nAlignment, TCHAR* ptcText);
SBAPI void _stdcall LinePrint_Image_Print(BOOL bAppend, float fX, char* pFileName);


#define DEV_OPT_NORMAL					0x0 // 0:Normal
#define DEV_OPT_TEAR					0x1 // 1:TearOff
#define DEV_OPT_PEEL					0x2 // 2:PeelOff
#define DEV_OPT_CUTTER					0x4 // 4:Cutter
#define DEV_OPT_TAPPRINT				0x8 // 8:Tap to Print